﻿#define TS200

using System;
using System.Data;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Globalization;
using System.IO;
using System.Windows.Forms;
using Tekla.Structures.Model;
using Tekla.Technology.Akit.UserScript;
using System.Data.OleDb;
using TSM = Tekla.Structures.Model;
using TS = Tekla.Structures;
using System.Threading;
using EXCEL = Excel;
using System.Reflection;




namespace Tekla.Technology.Akit.UserScript
{  

    public static class Const
    {

        public const string MACRO_HELP_FILE_NAME = "CSDOTNET.chm";
        public const string MACRO_HELP_LINK = "ML004%20-%20Copy%20Objects/ML004%20-%20Copy%20Objects.htm";

        public static int YES = 0;
        public static int NO = 1;

        public static int IMPORT_COMPONENTS_FILE = 2;
        public static int SIMPLE_COPY_FILE = 1;
        public static int COPY_ROTATE_FILE = 0;

        public static int MM_INDEX = 0;
        public static int CM_INDEX = 1;
        public static int M_INDEX = 2;
        public static int KM_INDEX = 3;
        public static int INCH_INDEX = 4;

        public static double MM_VALUE = 1;
        public static double CM_VALUE = 10;
        public static double M_VALUE = 1000;
        public static double KM_VALUE = 1000000;
        public static double INCH_VALUE = 25.4;

        public static int SHOW_DUPLICATES_DIALOG_AND_ASK = 0;

        public static double DEG_TO_RAD = Math.PI / 180.0;
        public static double RAD_TO_DEG = 180.0 / Math.PI;
        public static double CS_EPSILON = 0.01;

        public const int CCP_NO_TYPE = -1;
        public const int CCP_TYPE_STRING = 0;
        public const int CCP_TYPE_DOUBLE = 1;
        public const int CCP_TYPE_INT = 2;

        public const int DIR_1_P = 0;
        public const int DIR_P_Z = 1;
        public const int DIR_M_Z = 2;
        public const int DIR_P_X = 3;
        public const int DIR_M_X = 4;
        public const int DIR_P_Y = 5;
        public const int DIR_M_Y = 6;

       public static double NUMBER_TOO_SMALL_FOR_ROTATING_CC = 0.6;
       public static double NUMBER_TO_ADD_WHEN_ROTATING_CC = 10.0;


        //public static readonly string[] paramStrings = new string[] {"Text", "Profile", "Material", "Name", "String", 
        //                                 "albl_thickness","albl_height","albl_length","albl_weight","albl_top_level","albl_bot_level"};

        //public static readonly string[] paramDoubles = new string[] {"Float", "Length", "Width", "Thickness", "Distance", "Double", 
        //                                 "Volume","Weight"};

        //public static readonly string[] paramInts = new string[] {"Option", "Decimal", "Yes/No", "Class", "Integer"};

        public const string CCP_TYPE_STRING_STR = "CHARACTER";
        public const string CCP_TYPE_DOUBLE_STR = "FLOAT";
        public const string CCP_TYPE_INT_STR =    "INTEGER";

        public const int HEAD_ROW_NO = 1;
        public const int DATA_TYPE_ROW_NO = 2;

        public static int FIRST_PARAMETER_COLUMN = 29;
        public static int FIRST_PARAMETER_COLUMN_TEXT = 14;

        public static bool GT(double a, double b) //greater then
        {
            if ((a - b) > CS_EPSILON) return true;
            return false;
        }

        public static bool LT(double a, double b) //lower then
        {
            return GT(b, a);
        }

        public static bool GE(double a, double b) //greater or equal
        {
            return !LT(a, b);
        }

        public static bool LE(double a, double b) //lower or equal
        {
            return !GT(a, b);
        }

        public static bool IN(double a, double b, double c) //is a between b&c or a = b
        {
            return (GE(a, b) && LT(a, c));
        }

        public static bool IX(double a, double b, double c) //is a between b&c or a = c
        {
            return (GT(a, b) && LE(a, c));
        }

        public static bool EQ(double a, double b) // a equal b 
        {
            return (GE(a, b) && LE(a, b));
        }

        public static bool NE(double a, double b) // a non-equal b
        {
            return !EQ(a, b);
        }
    }


    public class MoveObjectsForm : System.Windows.Forms.Form
    {

        TSM.Model model;
        string originalText; 
        Tekla.Technology.Akit.IScript akit;

        private System.ComponentModel.IContainer components = null;

        private static string m_TSLanguage;

        private TeklaControls.TeklaSaveLoadControl teklaSaveLoadControl1;
        private System.Windows.Forms.Label lb_rowStart;
        private System.Windows.Forms.Label lb_rowTo;
        private System.Windows.Forms.Label lb_startColumn;
        private System.Windows.Forms.Label lb_endColumn;
        private System.Windows.Forms.Label lb_columnEnd;
        private System.Windows.Forms.Label lb_direction;
        private System.Windows.Forms.Button button_MoveObjects;
        private System.Windows.Forms.TabPage tabPage_About;
        private System.Windows.Forms.TabPage tabPage_copyObject;
        private System.Windows.Forms.TabPage tabPage_importComponents;        
        private System.Windows.Forms.TabControl tabControl1;
       // private System.Windows.Forms.Button button_SimpleCopyObjects;
        private System.Windows.Forms.Button button_Cancel;
        private System.Windows.Forms.Label lb_renameParts;
        private System.Windows.Forms.ComboBox comboBox_renameParts;
        private System.Windows.Forms.Label lb_copyType;
        private System.Windows.Forms.ComboBox comboBox_copyType;
        private System.Windows.Forms.Label lb_inputFile;
        private System.Windows.Forms.Label lb_sheetName;
        private System.Windows.Forms.TextBox textBox_ExcelFile;
        private System.Windows.Forms.Button button_OpenFile;
        private System.Windows.Forms.ComboBox comboBox_sheets;
        private System.Windows.Forms.TextBox textBox_startRow;
        private System.Windows.Forms.TextBox textBox_endRow;
        private System.Windows.Forms.ComboBox comboBox_direction;
        private System.Windows.Forms.TextBox textBox_startColumn;
        private System.Windows.Forms.TextBox textBox_endColumn;
        private System.Windows.Forms.ComboBox comboBox_showLines;
        private System.Windows.Forms.ComboBox comboBox_duplicates;
        private System.Windows.Forms.Label lb_showLines;
        private System.Windows.Forms.Label lb_duplicates;
        private System.Windows.Forms.Label lb_units;
        private System.Windows.Forms.ComboBox comboBox_units;
       // private System.Windows.Forms.Label lb_grid;
       // private System.Windows.Forms.ComboBox comboBox_grid;
        private System.Windows.Forms.GroupBox groupBox1_special_offsets;
        private System.Windows.Forms.Label label_dZ;
        private System.Windows.Forms.Label label_dY;
        private System.Windows.Forms.Label label_dX;
        private System.Windows.Forms.TextBox textBox_dZ;
        private System.Windows.Forms.TextBox textBox_dY;
        private System.Windows.Forms.TextBox textBox_dX;
        private System.Windows.Forms.GroupBox groupBox_data_input;
        private System.Windows.Forms.GroupBox groupBox_component;
        private System.Windows.Forms.GroupBox groupBox_extra;
        private System.Windows.Forms.PictureBox pictureBox_About_ConstrusoftBMP;
        private System.Windows.Forms.Label label_About_Version;
        private System.Windows.Forms.Label label_About_Date;
        private System.Windows.Forms.HelpProvider helpProvider1;
       

        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code

     
        private void InitializeComponent()
        {
            this.lb_rowStart = new System.Windows.Forms.Label();
            this.lb_rowTo = new System.Windows.Forms.Label();
            this.lb_startColumn = new System.Windows.Forms.Label();
            this.lb_endColumn = new System.Windows.Forms.Label();
            this.lb_direction = new System.Windows.Forms.Label();
            this.button_MoveObjects = new System.Windows.Forms.Button();
            this.tabControl1 = new System.Windows.Forms.TabControl();
            this.tabPage_copyObject = new System.Windows.Forms.TabPage();
            this.tabPage_importComponents = new System.Windows.Forms.TabPage();            
            this.tabPage_About = new System.Windows.Forms.TabPage(); 
            // this.button_SimpleCopyObjects = new System.Windows.Forms.Button();
            this.button_Cancel = new System.Windows.Forms.Button();
            this.lb_renameParts = new System.Windows.Forms.Label();
            this.comboBox_renameParts = new System.Windows.Forms.ComboBox();
            this.lb_copyType = new System.Windows.Forms.Label();
            this.comboBox_copyType = new System.Windows.Forms.ComboBox();
            this.lb_inputFile = new System.Windows.Forms.Label();
            this.lb_sheetName = new System.Windows.Forms.Label();
            this.textBox_ExcelFile = new System.Windows.Forms.TextBox();
            this.button_OpenFile = new System.Windows.Forms.Button();
            this.comboBox_sheets = new System.Windows.Forms.ComboBox();
            this.textBox_startRow = new System.Windows.Forms.TextBox();
            this.textBox_endRow = new System.Windows.Forms.TextBox();

            this.comboBox_direction = new System.Windows.Forms.ComboBox();
            this.textBox_startColumn = new System.Windows.Forms.TextBox();
            this.textBox_endColumn = new System.Windows.Forms.TextBox();
            this.comboBox_showLines = new System.Windows.Forms.ComboBox();
            this.comboBox_duplicates = new System.Windows.Forms.ComboBox();
            this.comboBox_units = new System.Windows.Forms.ComboBox();
          //  this.comboBox_grid = new System.Windows.Forms.ComboBox();
            this.lb_showLines = new System.Windows.Forms.Label();
            this.lb_duplicates = new System.Windows.Forms.Label();
            this.lb_units = new System.Windows.Forms.Label();
        //    this.lb_grid = new System.Windows.Forms.Label();
            this.groupBox1_special_offsets = new System.Windows.Forms.GroupBox();
            this.label_dZ = new System.Windows.Forms.Label();
            this.label_dY = new System.Windows.Forms.Label();
            this.label_dX = new System.Windows.Forms.Label();
            this.textBox_dZ = new System.Windows.Forms.TextBox();
            this.textBox_dY = new System.Windows.Forms.TextBox();
            this.textBox_dX = new System.Windows.Forms.TextBox();
            this.groupBox_data_input = new System.Windows.Forms.GroupBox();
            this.groupBox_component = new System.Windows.Forms.GroupBox();
            this.groupBox1_special_offsets.SuspendLayout();
            this.groupBox_extra = new System.Windows.Forms.GroupBox();
            this.label_About_Date = new System.Windows.Forms.Label();
            this.label_About_Version = new System.Windows.Forms.Label();
            this.pictureBox_About_ConstrusoftBMP = new System.Windows.Forms.PictureBox();
            this.helpProvider1 = new System.Windows.Forms.HelpProvider();
            this.tabControl1.SuspendLayout();
            this.tabPage_copyObject.SuspendLayout();
            this.tabPage_About.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox_About_ConstrusoftBMP)).BeginInit();
            this.SuspendLayout();
            // 
            // lb_rowStart
            // 
            this.lb_rowStart.AutoSize = true;
            this.lb_rowStart.Location = new System.Drawing.Point(12, 81);
            this.lb_rowStart.Name = "lb_rowStart";
            this.lb_rowStart.Size = new System.Drawing.Size(57, 13);
            this.lb_rowStart.TabIndex = 0;
            this.lb_rowStart.Text = "Start Row:";
            this.lb_rowStart.Click += new System.EventHandler(this.lb_rowStart_Click);
            // 
            // lb_rowTo
            // 
            this.lb_rowTo.AutoSize = true;
            this.lb_rowTo.Location = new System.Drawing.Point(12, 113);
            this.lb_rowTo.Name = "lb_rowTo";
            this.lb_rowTo.Size = new System.Drawing.Size(54, 13);
            this.lb_rowTo.TabIndex = 0;
            this.lb_rowTo.Text = "End Row:";
            // 
            // lb_startColumn
            // 
            this.lb_startColumn.AutoSize = true;
            this.lb_startColumn.Location = new System.Drawing.Point(12, 54);
            this.lb_startColumn.Name = "lb_startColumn";
            this.lb_startColumn.Size = new System.Drawing.Size(57, 13);
            this.lb_startColumn.TabIndex = 0;
            this.lb_startColumn.Text = "Start column:";
            this.lb_startColumn.Click += new System.EventHandler(this.lb_rowStart_Click);
            // 
            // lb_endColumn
            // 
            this.lb_endColumn.AutoSize = true;
            this.lb_endColumn.Location = new System.Drawing.Point(12, 86);
            this.lb_endColumn.Name = "lb_endColumn";
            this.lb_endColumn.Size = new System.Drawing.Size(57, 13);
            this.lb_endColumn.TabIndex = 0;
            this.lb_endColumn.Text = "End column:";
            this.lb_endColumn.Click += new System.EventHandler(this.lb_rowStart_Click);
            // 
            // lb_direction
            // 
            this.lb_direction.AutoSize = true;
            this.lb_direction.Location = new System.Drawing.Point(12, 22);
            this.lb_direction.Name = "lb_direction";
            this.lb_direction.Size = new System.Drawing.Size(69, 13);
            this.lb_direction.TabIndex = 0;
            this.lb_direction.Text = "2nd point:";
            // 
            // button_MoveObjects
            // 
            this.button_MoveObjects.Location = new System.Drawing.Point(367, 315);
            this.button_MoveObjects.Name = "button_MoveObjects";
            this.button_MoveObjects.Size = new System.Drawing.Size(80, 25);
            this.button_MoveObjects.TabIndex = 15;
            this.button_MoveObjects.Text = "Copy";
            this.button_MoveObjects.UseVisualStyleBackColor = true;
            this.button_MoveObjects.Click += new System.EventHandler(this.button_MoveObjects_Click);
            // 
            // button_SimpleCopyObjects
            // 
            //this.button_SimpleCopyObjects.Location = new System.Drawing.Point(113, 295);
            //this.button_SimpleCopyObjects.Name = "button_SimpleCopyObjects";
            //this.button_SimpleCopyObjects.Size = new System.Drawing.Size(80, 25);
            //this.button_SimpleCopyObjects.TabIndex = 14;
            //this.button_SimpleCopyObjects.Text = "Simple Copy";
            //this.button_SimpleCopyObjects.UseVisualStyleBackColor = true;
            //this.button_SimpleCopyObjects.Click += new System.EventHandler(this.button_SimpleCopyObjects_Click);
            // 
            // button_Cancel
            // 
            this.button_Cancel.Location = new System.Drawing.Point(450, 315);
            this.button_Cancel.Name = "button_Cancel";
            this.button_Cancel.Size = new System.Drawing.Size(80, 25);
            this.button_Cancel.TabIndex = 16;
            this.button_Cancel.Text = "Ok";
            this.button_Cancel.UseVisualStyleBackColor = true;
            this.button_Cancel.Click += new System.EventHandler(this.button_Cancel_Click);
            // 
            // textBox_startRow
            // 
            this.textBox_startRow.Location = new System.Drawing.Point(102, 78);
            this.textBox_startRow.Name = "textBox_startRow";
            this.textBox_startRow.Size = new System.Drawing.Size(168, 20);
            this.textBox_startRow.TabIndex = 6;
            this.textBox_startRow.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.textBox_startRow_KeyPress);
            // 
            // textBox_endRow
            // 
            this.textBox_endRow.Location = new System.Drawing.Point(102, 110);
            this.textBox_endRow.Name = "textBox_endRow";
            this.textBox_endRow.Size = new System.Drawing.Size(168, 20);
            this.textBox_endRow.TabIndex = 7;
            this.textBox_endRow.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.textBox_endRow_KeyPress);
            // 
            // textBox_startColumn
            // 
            this.textBox_startColumn.Location = new System.Drawing.Point(102, 51);
            this.textBox_startColumn.Name = "textBox_startColumn";
            this.textBox_startColumn.Size = new System.Drawing.Size(168, 20);
            this.textBox_startColumn.TabIndex = 2;
            // 
            // textBox_endColumn
            // 
            this.textBox_endColumn.Location = new System.Drawing.Point(102, 83);
            this.textBox_endColumn.Name = "textBox_endColumn";
            this.textBox_endColumn.Size = new System.Drawing.Size(168, 20);
            this.textBox_endColumn.TabIndex = 3;         
            //this.textBox_startColumn.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.textBox_startRow_KeyPress);
            // 
            // comboBox_copyType
            // 
            this.comboBox_direction.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBox_direction.FormattingEnabled = true;
            this.comboBox_direction.Items.AddRange(new object[] {
            "One Point",
            "+z",
            "-z",
            "+x",
            "-x",
            "+y",
            "-y"});
            this.comboBox_direction.Location = new System.Drawing.Point(102, 19);
            this.comboBox_direction.Name = "comboBox_direction";
            this.comboBox_direction.Size = new System.Drawing.Size(167, 21);
            this.comboBox_direction.TabIndex = 1;
            this.comboBox_direction.SelectedIndex = 0;
            // 
            // lb_renameParts
            // 
            this.lb_renameParts.AutoSize = true;
            this.lb_renameParts.Location = new System.Drawing.Point(12, 145);
            this.lb_renameParts.Name = "lb_renameParts";
            this.lb_renameParts.Size = new System.Drawing.Size(76, 13);
            this.lb_renameParts.TabIndex = 0;
            this.lb_renameParts.Text = "Rename parts:";
            // 
            // comboBox_renameParts
            // 
            this.comboBox_renameParts.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBox_renameParts.FormattingEnabled = true;
            this.comboBox_renameParts.Items.AddRange(new object[] {
            "Yes",
            "No"});
            this.comboBox_renameParts.Location = new System.Drawing.Point(103, 142);
            this.comboBox_renameParts.Name = "comboBox_renameParts";
            this.comboBox_renameParts.Size = new System.Drawing.Size(167, 21);
            this.comboBox_renameParts.TabIndex = 8;
            this.comboBox_renameParts.SelectedIndex = 0;
            // 
            // lb_copyType
            // 
            this.lb_copyType.AutoSize = true;
            this.lb_copyType.Location = new System.Drawing.Point(12, 177);
            this.lb_copyType.Name = "lb_copyType";
            this.lb_copyType.Size = new System.Drawing.Size(76, 13);
            this.lb_copyType.TabIndex = 0;
            this.lb_copyType.Text = "Copy type:";
            // 
            // comboBox_copyType
            // 
            this.comboBox_copyType.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBox_copyType.FormattingEnabled = true;
            this.comboBox_copyType.Items.AddRange(new object[] {
            "Advanced",
            "Simple",
            "Import components"});
            this.comboBox_copyType.Location = new System.Drawing.Point(103, 174);
            this.comboBox_copyType.Name = "comboBox_copyType";
            this.comboBox_copyType.Size = new System.Drawing.Size(167, 21);
            this.comboBox_copyType.TabIndex = 9;
            this.comboBox_copyType.SelectedIndex = 0;
            // 
            // lb_inputFile
            // 
            this.lb_inputFile.AutoSize = true;
            this.lb_inputFile.Location = new System.Drawing.Point(12, 22);
            this.lb_inputFile.Name = "lb_inputFile";
            this.lb_inputFile.Size = new System.Drawing.Size(53, 13);
            this.lb_inputFile.TabIndex = 0;
            this.lb_inputFile.Text = "Input File:";
            // 
            // lb_sheetName
            // 
            this.lb_sheetName.AutoSize = true;
            this.lb_sheetName.Location = new System.Drawing.Point(12, 50);
            this.lb_sheetName.Name = "lb_sheetName";
            this.lb_sheetName.Size = new System.Drawing.Size(69, 13);
            this.lb_sheetName.TabIndex = 0;
            this.lb_sheetName.Text = "Sheet Name:";
            // 
            // textBox_ExcelFile
            // 
            this.textBox_ExcelFile.Location = new System.Drawing.Point(102, 19);
            this.textBox_ExcelFile.Name = "textBox_ExcelFile";
            this.textBox_ExcelFile.Size = new System.Drawing.Size(168, 20);
            this.textBox_ExcelFile.TabIndex = 3;
            // 
            // button_OpenFile
            // 
            this.button_OpenFile.Location = new System.Drawing.Point(276, 19);
            this.button_OpenFile.Name = "button_OpenFile";
            this.button_OpenFile.Size = new System.Drawing.Size(28, 20);
            this.button_OpenFile.TabIndex = 4;
            this.button_OpenFile.Text = "...";
            this.button_OpenFile.UseVisualStyleBackColor = true;
            this.button_OpenFile.Click += new System.EventHandler(this.button_OpenFile_Click);
            // 
            // comboBox_sheets
            // 
            this.comboBox_sheets.FormattingEnabled = true;
            this.comboBox_sheets.Location = new System.Drawing.Point(102, 47);
            this.comboBox_sheets.Name = "comboBox_sheets";
            this.comboBox_sheets.Size = new System.Drawing.Size(168, 21);
            this.comboBox_sheets.TabIndex = 5;
            // 
            // comboBox_showLines
            // 
            this.comboBox_showLines.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBox_showLines.FormattingEnabled = true;
            this.comboBox_showLines.Items.AddRange(new object[] {
            "Yes",
            "No"});
            this.comboBox_showLines.Location = new System.Drawing.Point(78, 19);
            this.comboBox_showLines.Name = "comboBox_showLines";
            this.comboBox_showLines.Size = new System.Drawing.Size(87, 21);
            this.comboBox_showLines.TabIndex = 17;
            this.comboBox_showLines.SelectedIndex = 1;
            // 
            // lb_showLines
            // 
            this.lb_showLines.AutoSize = true;
            this.lb_showLines.Location = new System.Drawing.Point(11, 22);
            this.lb_showLines.Name = "lb_showLines";
            this.lb_showLines.Size = new System.Drawing.Size(61, 13);
            this.lb_showLines.TabIndex = 0;
            this.lb_showLines.Text = "Show lines:";
            // 
            // comboBox_duplicates
            // 
            this.comboBox_duplicates.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBox_duplicates.FormattingEnabled = true;
            this.comboBox_duplicates.Items.AddRange(new object[] {
            "Show dialog",
            "Keep",
            "Delete"});
            this.comboBox_duplicates.Location = new System.Drawing.Point(78, 67);
            this.comboBox_duplicates.Name = "comboBox_duplicates";
            this.comboBox_duplicates.Size = new System.Drawing.Size(87, 21);
            this.comboBox_duplicates.TabIndex = 18;
            this.comboBox_duplicates.SelectedIndex = 0;
            // 
            // lb_duplicates
            // 
            this.lb_duplicates.AutoSize = true;
            this.lb_duplicates.Location = new System.Drawing.Point(11, 70);
            this.lb_duplicates.Name = "lb_duplicates";
            this.lb_duplicates.Size = new System.Drawing.Size(61, 13);
            this.lb_duplicates.TabIndex = 0;
            this.lb_duplicates.Text = "Duplicates:";
            // 
            // lb_grid
            // 
          /*  this.lb_grid.AutoSize = true;
            this.lb_grid.Location = new System.Drawing.Point(11, 46);
            this.lb_grid.Name = "lb_grid";
            this.lb_grid.Size = new System.Drawing.Size(61, 13);
            this.lb_grid.TabIndex = 0;
            this.lb_grid.Text = "Copy grid:";
            // 
            // comboBox_grid
            // 
            this.comboBox_grid.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBox_grid.FormattingEnabled = true;
            this.comboBox_grid.Items.AddRange(new object[] {
            "Yes",
            "No"});
            this.comboBox_grid.Location = new System.Drawing.Point(78, 43);
            this.comboBox_grid.Name = "comboBox_grid";
            this.comboBox_grid.Size = new System.Drawing.Size(87, 21);
            this.comboBox_grid.TabIndex = 19;
            this.comboBox_grid.SelectedIndex = 1;*/
            // 
            // lb_units
            // 
            this.lb_units.AutoSize = true;
            this.lb_units.Location = new System.Drawing.Point(11, 46);
            this.lb_units.Name = "lb_units";
            this.lb_units.Size = new System.Drawing.Size(61, 13);
            this.lb_units.TabIndex = 0;
            this.lb_units.Text = "Units:";
            // 
            // comboBox_units
            // 
            this.comboBox_units.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBox_units.FormattingEnabled = true;
            this.comboBox_units.Items.AddRange(new object[] {
            "mm",
            "cm",
            "m",
            "km",
            "inch"});
            this.comboBox_units.Location = new System.Drawing.Point(78, 43);
            this.comboBox_units.Name = "comboBox_units";
            this.comboBox_units.Size = new System.Drawing.Size(87, 21);
            this.comboBox_units.TabIndex = 17;
            this.comboBox_units.SelectedIndex = 2;

            // 
            // groupBox1_special_offsets
            // 
            this.groupBox1_special_offsets.Controls.Add(this.label_dZ);
            this.groupBox1_special_offsets.Controls.Add(this.label_dY);
            this.groupBox1_special_offsets.Controls.Add(this.label_dX);
            this.groupBox1_special_offsets.Controls.Add(this.textBox_dZ);
            this.groupBox1_special_offsets.Controls.Add(this.textBox_dY);
            this.groupBox1_special_offsets.Controls.Add(this.textBox_dX);
            this.groupBox1_special_offsets.Location = new System.Drawing.Point(329, 14);
            this.groupBox1_special_offsets.Name = "groupBox1_special_offsets";
            this.groupBox1_special_offsets.Size = new System.Drawing.Size(171, 96);
            this.groupBox1_special_offsets.TabIndex = 9;
            this.groupBox1_special_offsets.TabStop = false;
            this.groupBox1_special_offsets.Text = "Special offsets (mm)";
            // 
            // label_dZ
            // 
            this.label_dZ.AutoSize = true;
            this.label_dZ.Location = new System.Drawing.Point(17, 69);
            this.label_dZ.Name = "label_dZ";
            this.label_dZ.Size = new System.Drawing.Size(20, 13);
            this.label_dZ.TabIndex = 0;
            this.label_dZ.Text = "dZ";
            // 
            // label_dY
            // 
            this.label_dY.AutoSize = true;
            this.label_dY.Location = new System.Drawing.Point(17, 45);
            this.label_dY.Name = "label_dY";
            this.label_dY.Size = new System.Drawing.Size(20, 13);
            this.label_dY.TabIndex = 0;
            this.label_dY.Text = "dY";
            // 
            // label_dX
            // 
            this.label_dX.AutoSize = true;
            this.label_dX.Location = new System.Drawing.Point(17, 23);
            this.label_dX.Name = "label_dX";
            this.label_dX.Size = new System.Drawing.Size(20, 13);
            this.label_dX.TabIndex = 0;
            this.label_dX.Text = "dX";
            // 
            // textBox_dZ
            // 
            this.textBox_dZ.Location = new System.Drawing.Point(52, 66);
            this.textBox_dZ.Name = "textBox_dZ";
            this.textBox_dZ.Size = new System.Drawing.Size(113, 20);
            this.textBox_dZ.TabIndex = 12;
            this.textBox_dZ.Text = "0.0";
            this.textBox_dZ.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.textBox_dZ_KeyPress);
            this.textBox_dZ.Validated += new System.EventHandler(this.textBox_dZ_Validated);        
            this.textBox_dZ.TextChanged += new System.EventHandler(this.textBox_dZ_TextChanged);
            // 
            // textBox_dY
            // 
            this.textBox_dY.Location = new System.Drawing.Point(52, 42);
            this.textBox_dY.Name = "textBox_dY";
            this.textBox_dY.Size = new System.Drawing.Size(113, 20);
            this.textBox_dY.TabIndex = 11;
            this.textBox_dY.Text = "0.0";
            this.textBox_dY.Validated += new System.EventHandler(this.textBox_dY_Validated);
            this.textBox_dY.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.textBox_dY_KeyPress);
            this.textBox_dY.TextChanged += new System.EventHandler(this.textBox_dY_TextChanged);
            // 
            // textBox_dX
            // 
            this.textBox_dX.Location = new System.Drawing.Point(52, 19);
            this.textBox_dX.Name = "textBox_dX";
            this.textBox_dX.Size = new System.Drawing.Size(113, 20);
            this.textBox_dX.TabIndex = 10;
            this.textBox_dX.Text = "0.0";
            this.textBox_dX.Validated += new System.EventHandler(this.textBox_dX_Validated);
            this.textBox_dX.TextChanged += new System.EventHandler(this.textBox_dX_TextChanged);
            this.textBox_dX.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.textBox_dX_KeyPress);
            // 
            // groupBox_data_input
            // 
            this.groupBox_data_input.Controls.Add(this.lb_rowTo);
            this.groupBox_data_input.Controls.Add(this.lb_rowStart);
            this.groupBox_data_input.Controls.Add(this.textBox_endRow);
            this.groupBox_data_input.Controls.Add(this.textBox_startRow);
            this.groupBox_data_input.Controls.Add(this.textBox_ExcelFile);
            this.groupBox_data_input.Controls.Add(this.lb_sheetName);
            this.groupBox_data_input.Controls.Add(this.comboBox_sheets);
            this.groupBox_data_input.Controls.Add(this.button_OpenFile);
            this.groupBox_data_input.Controls.Add(this.lb_inputFile);
            this.groupBox_data_input.Controls.Add(this.lb_renameParts);
            this.groupBox_data_input.Controls.Add(this.comboBox_renameParts);
            this.groupBox_data_input.Controls.Add(this.lb_copyType);
            this.groupBox_data_input.Controls.Add(this.comboBox_copyType);            
            this.groupBox_data_input.Location = new System.Drawing.Point(12, 14);
            this.groupBox_data_input.Name = "groupBox_data_input";
            this.groupBox_data_input.Size = new System.Drawing.Size(311, 208);
            this.groupBox_data_input.TabIndex = 2;
            this.groupBox_data_input.TabStop = false;
            this.groupBox_data_input.Text = "Input data";
            // 
            // groupBox_component
            // 
            //this.groupBox_component.Controls.Add(this.lb_columnEnd);
            this.groupBox_component.Controls.Add(this.lb_startColumn);
            this.groupBox_component.Controls.Add(this.lb_endColumn);
            this.groupBox_component.Controls.Add(this.lb_direction);
            this.groupBox_component.Controls.Add(this.textBox_startColumn);
            this.groupBox_component.Controls.Add(this.textBox_endColumn);
            this.groupBox_component.Controls.Add(this.comboBox_direction);
            this.groupBox_component.Location = new System.Drawing.Point(12, 14);
            this.groupBox_component.Name = "groupBox_component";
            this.groupBox_component.Size = new System.Drawing.Size(311, 115);
            this.groupBox_component.TabIndex = 2;
            this.groupBox_component.TabStop = false;
            this.groupBox_component.Text = "Import Component Settings";
            // 
            // groupBox_extra
            // 
            this.groupBox_extra.Controls.Add(this.comboBox_units);
            this.groupBox_extra.Controls.Add(this.lb_units);
            //this.groupBox_extra.Controls.Add(this.lb_grid);
            //this.groupBox_extra.Controls.Add(this.comboBox_grid);
            this.groupBox_extra.Controls.Add(this.lb_showLines);
            this.groupBox_extra.Controls.Add(this.comboBox_showLines);
            this.groupBox_extra.Controls.Add(this.lb_duplicates);
            this.groupBox_extra.Controls.Add(this.comboBox_duplicates);
            this.groupBox_extra.Location = new System.Drawing.Point(329, 113);
            this.groupBox_extra.Name = "groupBox_extra";
            this.groupBox_extra.Size = new System.Drawing.Size(171, 98);
            this.groupBox_extra.TabIndex = 13;
            this.groupBox_extra.TabStop = false;
            this.groupBox_extra.Text = "Extra";
            // 
            // tabControl1
            // 
            this.tabControl1.Controls.Add(this.tabPage_copyObject);
            this.tabControl1.Controls.Add(this.tabPage_importComponents);
            this.tabControl1.Controls.Add(this.tabPage_About);
            this.tabControl1.Location = new System.Drawing.Point(12, 52);
            this.tabControl1.Name = "tabControl1";
            this.tabControl1.SelectedIndex = 0;
            this.tabControl1.Size = new System.Drawing.Size(522, 250);
            this.tabControl1.TabIndex = 10;           
            // 
            // tabPage_copyObject
            // 
            this.tabPage_copyObject.BackColor = System.Drawing.SystemColors.Control;
            this.tabPage_copyObject.Controls.Add(this.groupBox_extra);
            this.tabPage_copyObject.Controls.Add(this.groupBox_data_input);
            this.tabPage_copyObject.Controls.Add(this.groupBox1_special_offsets);
            //this.tabPage_copyObject.Controls.Add(this.button_MoveObjects);
            //this.tabPage_copyObject.Controls.Add(this.button_SimpleCopyObjects);
            //this.tabPage_copyObject.Controls.Add(this.button_Cancel);
            //this.tabPage_copyObject.Location = new System.Drawing.Point(4, 22);
            this.tabPage_copyObject.Name = "tabPage_copyObject";
            this.tabPage_copyObject.Size = new System.Drawing.Size(532, 250);
            this.tabPage_copyObject.TabIndex = 0;
            this.tabPage_copyObject.Text = "Copy Object";
            // 
            // tabPage_importComponents
            // 
            this.tabPage_importComponents.BackColor = System.Drawing.SystemColors.Control;
            this.tabPage_importComponents.Controls.Add(this.groupBox_component);
            //this.tabPage_importComponents.Controls.Add(this.groupBox_data_input);
            //this.tabPage_importComponents.Controls.Add(this.groupBox1_special_offsets);
            //this.tabPage_copyObject.Controls.Add(this.button_MoveObjects);
            //this.tabPage_copyObject.Controls.Add(this.button_SimpleCopyObjects);
            //this.tabPage_copyObject.Controls.Add(this.button_Cancel);
            //this.tabPage_copyObject.Location = new System.Drawing.Point(4, 22);
            this.tabPage_importComponents.Name = "tabPage_importComponents";
            this.tabPage_importComponents.Size = new System.Drawing.Size(532, 250);
            this.tabPage_importComponents.TabIndex = 1;
            this.tabPage_importComponents.Text = "Import Components";
            // 
            // tabPage_About
            // 
            this.tabPage_About.BackColor = System.Drawing.SystemColors.Control;
            this.tabPage_About.Controls.Add(this.label_About_Date);
            this.tabPage_About.Controls.Add(this.label_About_Version);
            this.tabPage_About.Controls.Add(this.pictureBox_About_ConstrusoftBMP);
            this.tabPage_About.Location = new System.Drawing.Point(4, 22);
            this.tabPage_About.Name = "tabPage_About";
            this.tabPage_About.Size = new System.Drawing.Size(532, 207);
            this.tabPage_About.TabIndex = 2;
            this.tabPage_About.Text = "About";
            // 
            // label_About_Date
            // 
            this.label_About_Date.AutoSize = true;
            this.label_About_Date.Location = new System.Drawing.Point(158, 20);
            this.label_About_Date.Name = "label_About_Date";
            this.label_About_Date.Size = new System.Drawing.Size(99, 13);
            this.label_About_Date.TabIndex = 2;
            this.label_About_Date.Text = "Date     20.01.2012";
            // 
            // label_About_Version
            // 
            this.label_About_Version.AutoSize = true;
            this.label_About_Version.Location = new System.Drawing.Point(43, 20);
            this.label_About_Version.Name = "label_About_Version";
            this.label_About_Version.Size = new System.Drawing.Size(78, 13);
            this.label_About_Version.TabIndex = 1;

//#if TS200 - rewrite this for each version
            this.label_About_Version.Text = "Version:    TS 20.0";
//#endif
            // 
            // pictureBox_About_ConstrusoftBMP
            // 
            this.pictureBox_About_ConstrusoftBMP.Location = new System.Drawing.Point(5, 46);
            this.pictureBox_About_ConstrusoftBMP.Name = "pictureBox_About_ConstrusoftBMP";
            this.pictureBox_About_ConstrusoftBMP.Size = new System.Drawing.Size(305, 79);
            this.pictureBox_About_ConstrusoftBMP.TabIndex = 0;
            this.pictureBox_About_ConstrusoftBMP.TabStop = false;
            this.pictureBox_About_ConstrusoftBMP.Visible = false;
            // 
            // Form1
            //   
            this.TopMost = true;
            this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
            this.ClientSize = new System.Drawing.Size(549, 350);
            this.Controls.Add(this.button_Cancel);
            this.Controls.Add(this.button_MoveObjects);
            //this.Controls.Add(this.button_SimpleCopyObjects);
            /*
            this.Controls.Add(this.groupBox_data_input);
            this.Controls.Add(this.groupBox1_special_offsets);
            this.Controls.Add(this.groupBox_extra);*/
            this.Controls.Add(this.tabControl1);
            this.tabControl1.ResumeLayout(false);
            this.tabPage_copyObject.ResumeLayout(false);
            this.tabPage_importComponents.ResumeLayout(false);            
            this.tabPage_copyObject.PerformLayout();
            this.tabPage_About.ResumeLayout(false);
            this.tabPage_About.PerformLayout();
            //this.Controls.Add(this.tabPage_copyObject);
            this.Name = "CS002 Move Objects"; //(TS15.0)";
            this.Text = "Construsoft - Copy Objects (ML004)"; //(TS15.0)";//it's copy objects
            this.ResumeLayout(false);
            this.PerformLayout();            
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.MaximizeBox = false;

        }

        private void Loaded_Attributes(object sender, System.EventArgs e)
        {
            //read sheets names when load tekla attributes
            FillComboboxWithSheetsNames(ref textBox_ExcelFile, ref comboBox_sheets);
        }

        #endregion

	  

        //constructor
        public MoveObjectsForm(Tekla.Technology.Akit.IScript akit_in)
        {
            model = new TSM.Model();

            this.akit = akit_in;
                    
		    InitializeLanguage();
	        InitializeComponent();

            InitializeHelp();

            // Add the saveLoadControl
            this.teklaSaveLoadControl1 = new TeklaControls.TeklaSaveLoadControl("CS002_MoveObj", m_TSLanguage);
            this.teklaSaveLoadControl1.Dock = System.Windows.Forms.DockStyle.Top;
            this.teklaSaveLoadControl1.Name = "teklaSaveLoadControl1";
            this.teklaSaveLoadControl1.TabIndex = 1;
            this.teklaSaveLoadControl1.PathToHelpFile = this.helpProvider1.HelpNamespace;
            this.teklaSaveLoadControl1.buttonLoad.Click += new System.EventHandler(this.Loaded_Attributes);
            this.Controls.Add(this.teklaSaveLoadControl1);
            //SetAttributeValue(this.textBox_startColumn, "27");
            //SetAttributeValue(this.textBox_endColumn, "28");


            M002LoadConstrusoftLogo();
            this.Show();
            this.teklaSaveLoadControl1.InitializeFileList();

            //read sheets names when load tekla attributes
            FillComboboxWithSheetsNames(ref textBox_ExcelFile, ref comboBox_sheets);

            //function ToString should return . in 123.5154 
            System.Globalization.CultureInfo ci = new System.Globalization.CultureInfo("en-US", false);
            System.Threading.Thread.CurrentThread.CurrentCulture = ci;


        }

        private void InitializeHelp()
        {
            Tekla.Structures.Model.Model model = new Tekla.Structures.Model.Model();
            string helpDirectory = string.Empty;

#if TS160 || TS161
            model.GetAdvancedOption("XS_HELP_PATH", ref helpDirectory);
#else
            Tekla.Structures.TeklaStructuresSettings.GetAdvancedOption("XS_HELP_PATH", ref helpDirectory);
#endif

            string pathToHelpFile = System.IO.Path.Combine(helpDirectory, Const.MACRO_HELP_FILE_NAME);

            if (!System.IO.File.Exists(pathToHelpFile))
            {
#if TS160 || TS161
                model.GetAdvancedOption("XS_HELP_SECONDARY_PATH", ref helpDirectory);
#else
                Tekla.Structures.TeklaStructuresSettings.GetAdvancedOption("XS_HELP_SECONDARY_PATH", ref helpDirectory);
#endif

                pathToHelpFile = System.IO.Path.Combine(helpDirectory, Const.MACRO_HELP_FILE_NAME);
            }

            if (!System.IO.File.Exists(pathToHelpFile))
            {
#if TS160 || TS161
                model.GetAdvancedOption("XS_DIR", ref helpDirectory);
#else
                Tekla.Structures.TeklaStructuresSettings.GetAdvancedOption("XS_DIR", ref helpDirectory);
#endif

                pathToHelpFile = System.IO.Path.Combine(helpDirectory, "nt\\help\\enu\\");
                pathToHelpFile = System.IO.Path.Combine(pathToHelpFile, Const.MACRO_HELP_FILE_NAME);
            }

            if (System.IO.File.Exists(pathToHelpFile))
            {
                helpProvider1.HelpNamespace = pathToHelpFile; //F1 pressing
                helpProvider1.SetHelpNavigator(this, HelpNavigator.Topic);
                helpProvider1.SetHelpKeyword(this, Const.MACRO_HELP_LINK);
                helpProvider1.SetShowHelp(this, true);
            }
        }

        private void M002LoadConstrusoftLogo()
        {
            Tekla.Structures.Model.Model model = new Tekla.Structures.Model.Model();

            string path = "";

#if TS150 || TS160 || TS161 
            model.GetAdvancedOption("XS_SYSTEM", ref path); 
#else
            TS.TeklaStructuresSettings.GetAdvancedOption("XS_SYSTEM", ref path);
#endif

            int index = 0;

            try
            {
                for (int i = 0; i < 3; i++)
                {
                    index = path.IndexOf('\\', index);
                    if ((index != -1) && (i == 2))
                    {
                        path = path.Substring(0, index);
                    }
                    else if (index == -1)
                    {
                        break;
                    }
                    else if (index < path.Length)
                    {
                        index++;
                    }
                }
            }
            catch (Exception)
            {
                return;
            }

            try
            {
                string path1 = path + "\\nt\\bitmaps\\cs_construsoft_logo.bmp";
                Bitmap bmp = new Bitmap(path1);
                Color transColor = bmp.GetPixel(0, 0);
                bmp.MakeTransparent(transColor);
                pictureBox_About_ConstrusoftBMP.Image = bmp;
                pictureBox_About_ConstrusoftBMP.Visible = true;
                return;
            }
            catch (Exception)
            {
            }
        }


        //methods
        private static void FillComboboxWithSheetsNames(ref System.Windows.Forms.TextBox textBox_ExcelFile, ref System.Windows.Forms.ComboBox comboBox_sheets)
        {
          
            if (textBox_ExcelFile.Text != "")
            {
                ArrayList sheet_names = new ArrayList();

                sheet_names = ReadFile.ReadSheetsNames(textBox_ExcelFile.Text);

                comboBox_sheets.Items.Clear();

                for (int i = 0; i < sheet_names.Count; i++)
                {
                    comboBox_sheets.Items.Add(sheet_names[i].ToString());
                }

                if(sheet_names.Count!=0)
                    comboBox_sheets.SelectedIndex = 0;
               
            }

        }

	    private static void InitializeLanguage()
        {
            m_TSLanguage = TeklaControls.Language.GetTeklaStructuresLanguage();
        }

        private void lb_rowStart_Click(object sender, EventArgs e)
        {

        }

        //angle in rad
        private void CsRotatePlaneX(double angle, ref TSM.WorkPlaneHandler wph)
        {
            TS.Geometry3d.Point p0;
            TS.Geometry3d.Vector p1, p2;
            p0 = new TS.Geometry3d.Point(0.0, 0.0, 0.0);
            p1 = new TS.Geometry3d.Vector(1000.0, 0.0, 0.0);
            p2 = new TS.Geometry3d.Vector(0.0, 1000.0 * Math.Cos(angle), 1000.0 * Math.Sin(angle));

            TSM.TransformationPlane new_trp = new TSM.TransformationPlane(p0, p1, p2);
            wph.SetCurrentTransformationPlane(new_trp);
        }
        
        //angle in rad
        private void CsRotatePlaneZ(double angle, ref TSM.WorkPlaneHandler wph)
        {
            TS.Geometry3d.Point p0;
            TS.Geometry3d.Vector p1, p2;
            p0 = new TS.Geometry3d.Point(0.0, 0.0, 0.0);
            p1 = new TS.Geometry3d.Vector(1000.0 * Math.Cos(angle), 1000.0 * Math.Sin(angle), 0.0);
            p2 = new TS.Geometry3d.Vector(-1000.0 * Math.Sin(angle), 1000.0 * Math.Cos(angle), 0.0);

            TSM.TransformationPlane new_trp = new TSM.TransformationPlane(p0, p1, p2);
            wph.SetCurrentTransformationPlane(new_trp);
        }

        private void GetAllObjectsIDs(bool only_selected, ref ArrayList ret_list)
        {
            

            TSM.ModelObjectEnumerator moe;

            if (only_selected == true)
#if TS150 || TS160 || TS161 
	    {
                moe = model.GetModelObjectSelector().GetSelectedObjects();
            }           
#else
 	    {
                TSM.UI.ModelObjectSelector mos = new TSM.UI.ModelObjectSelector();
                moe = mos.GetSelectedObjects();
            } 
#endif
            else
            {
                moe = model.GetModelObjectSelector().GetAllObjects();
            }


            moe.SelectInstances = false;
            
            //copy_id_into array_list
            while (moe.MoveNext())
                ret_list.Add(moe.Current.Identifier.ID);

        }

        //part_list have to contains ids
        private void SelectParts(ref ArrayList part_list)
        {
            TSM.UI.ModelObjectSelector sel = new TSM.UI.ModelObjectSelector();

            ArrayList selected_part = new ArrayList();

            for (int j = 0; j < part_list.Count; j++)
            {
                int id = (int)part_list[j];
                TSM.ModelObject mo = model.SelectModelObject(new TS.Identifier(id));
                selected_part.Add(mo);
            }

            sel.Select(selected_part);
        }

        private void DeleteCopiedGrids(ref ArrayList part_list)
        {
            for (int j = 0; j < part_list.Count; j++)
            {
                int id = (int)part_list[j];
                TSM.ModelObject mo = model.SelectModelObject(new TS.Identifier(id));

                TSM.Grid grid = mo as TSM.Grid;

                if (grid != null)
                {
                    grid.Delete();
                    j--;
                }
            }
        }

        private void RenameParts(ref ArrayList part_list, string new_name)
        {

            for (int j = 0; j < part_list.Count; j++)
            {
                int id = (int)part_list[j];
                TSM.ModelObject mo = model.SelectModelObject(new TS.Identifier(id));

                TSM.Part new_part = mo as TSM.Part;

               

                if (new_part != null)
                {
                    double a = 0.0;

                    new_part.GetReportProperty("RADIUS", ref a);

                    if (Const.NE(a,0.0))
                    {
                        //curved beam problem, modify destroy radius
                    
                        ArrayList curved_part_list = new ArrayList();
                        curved_part_list.Add(id);
                        SelectParts(ref curved_part_list);

                        akit.Callback("acmd_display_selected_object_dialog", "", "View_01 window_1");
                        akit.ValueChange("part_attrib", "name", new_name);
                        akit.PushButton("dia_pa_modify", "part_attrib");
                        akit.PushButton("dia_pa_cancel", "part_attrib");
                        
                        akit.ValueChange("diaConcretePanel", "name", new_name);
                        akit.PushButton("dia_pa_modify", "diaConcretePanel");
                        akit.PushButton("dia_pa_cancel", "diaConcretePanel");

                        akit.ValueChange("diaConcreteBeam", "name", new_name);
                        akit.PushButton("dia_pa_modify", "diaConcreteBeam");
                        akit.PushButton("dia_pa_cancel", "diaConcreteBeam");
       
                    }
                    else
                    {
                        new_part.Name = new_name;
                        new_part.Modify();
                    }
                }
            }
        }


        //return id_list2-id_list1  
        private void GetTwoArrayListsDiff(ref ArrayList id_list1, ref ArrayList id_list2, ref ArrayList ret_list)
        {

            foreach (int i in id_list2)
            {
                if (!id_list1.Contains(i))
                    ret_list.Add(i);
            }

            /*
            foreach (int i in id_list1)
            {
                if (!id_list2.Contains(i))
                    ret_list.Add(i);
            }*/

        }

       // private void button_SimpleCopyObjects_Click(object sender, EventArgs e)
        private void SimpleCopyObjects()
        {
            //akit.Clear();
            int startRow, endRow;
            TS.Geometry3d.Vector offsetVector;
            double coeficientOfUnits = GetUnits();
            ArrayList new_list = new ArrayList();
            ArrayList original_selected = new ArrayList();
            ArrayList all_original_objects = new ArrayList();
            ArrayList new_objects_id = new ArrayList(); 

            try
            {
                offsetVector = new TS.Geometry3d.Vector(ReadFile.GetDoubleFromString(textBox_dX.Text), ReadFile.GetDoubleFromString(textBox_dY.Text), ReadFile.GetDoubleFromString(textBox_dZ.Text));
            }
            catch (Exception ex)
            {
                MessageBox.Show("Special offset is not a numeric value.");
                return;
            }
            try
            {
                startRow = Convert.ToInt32(textBox_startRow.Text);
            }
            catch (Exception ex)
            {
                MessageBox.Show("Start Row is not a numeric value.");
                return;
            }
            try
            {
                endRow = Convert.ToInt32(textBox_endRow.Text);
            }
            catch (Exception ex)
            {
                MessageBox.Show("End Row is not a numeric value.");
                return;
            }


            if (textBox_ExcelFile.Text == "")
                return;


            //get excel rows data
            ArrayList moveDataFromFile;
            moveDataFromFile = new ArrayList();

            if (textBox_ExcelFile.Text.Contains(".xlsx") || textBox_ExcelFile.Text.Contains(".xls"))
            {
                if (comboBox_sheets.Text == "")
                    return;
                moveDataFromFile = ReadFile.ReadExcelFileSheet(textBox_ExcelFile.Text, comboBox_sheets.SelectedIndex+1, startRow, endRow,0,0, Const.SIMPLE_COPY_FILE,null);
            }
            else if (textBox_ExcelFile.Text.Contains(".txt"))
            {
                moveDataFromFile = ReadFile.ReadTextFile(textBox_ExcelFile.Text, startRow, endRow, 0,Const.SIMPLE_COPY_FILE,  null, '\t', ' ');
            }          
            else if (textBox_ExcelFile.Text.Contains(".csv"))
            {
                moveDataFromFile = ReadFile.ReadTextFile(textBox_ExcelFile.Text, startRow, endRow, 0, Const.SIMPLE_COPY_FILE, null, ';');
            }

            GetAllObjectsIDs(false, ref all_original_objects);//for del of grids
            GetAllObjectsIDs(true, ref original_selected);//for renaming


            if (original_selected.Count == 0)
            {
                MessageBox.Show("No model object selected.");
                return;
            }
                        
            //move object
            for (int i = 0; i < moveDataFromFile.Count; i++)
            {
                ArrayList id_list1, id_list2;
                id_list1 = new ArrayList();
                id_list2 = new ArrayList();
                new_objects_id = new ArrayList();

                //select(highlight) part selected by user
                SelectParts(ref original_selected);
                GetAllObjectsIDs(false, ref id_list1);

                ExcelRow er = moveDataFromFile[i] as ExcelRow;


                double newX = ((er.newPoint.X * coeficientOfUnits) + offsetVector.X);
                double newY = ((er.newPoint.Y * coeficientOfUnits) + offsetVector.Y);
                double newZ = ((er.newPoint.Z * coeficientOfUnits) + offsetVector.Z);
                //move selected objects
                akit.CommandStart("ail_copy_translate", "", "main_frame");
                akit.ValueChange("Copy", "dx", newX.ToString());
                akit.ValueChange("Copy", "dy", newY.ToString());
                akit.ValueChange("Copy", "dz", newZ.ToString());
                HandleKeepDulicatesDialog();
                akit.PushButton("dia_copy_apply", "Copy");
                akit.CommandEnd();
                model.CommitChanges();


                //get and select new objects - for rename
                GetAllObjectsIDs(false, ref id_list2);
                GetTwoArrayListsDiff(ref id_list1, ref id_list2, ref new_objects_id);
                SelectParts(ref new_objects_id);
                
                //rename parts
                if (comboBox_renameParts.SelectedIndex == 0 && er.newName != "")  //option Yes
                    RenameParts(ref new_objects_id, er.newName);  //!!!in 14.1 it destroy rotation attribute for beam                
            }
            akit.PushButton("dia_copy_cancel", "Copy");         


            //deleting of grids (new created)
           // if (comboBox_grid.SelectedIndex == Const.NO)
            {
                GetAllObjectsIDs(false, ref new_list);//for del of meshes
                GetTwoArrayListsDiff(ref all_original_objects, ref new_list, ref new_objects_id);
                SelectParts(ref new_objects_id);
                DeleteCopiedGrids(ref new_objects_id);            
                model.CommitChanges();               
            }
        }

        private double GetUnits()
        {
            switch (comboBox_units.SelectedIndex)
            {
                case 0: return Const.MM_VALUE;
                case 1: return Const.CM_VALUE;
                case 2: return Const.M_VALUE;
                case 3: return Const.KM_VALUE;
                case 4: return Const.INCH_VALUE;
                default: return Const.M_VALUE;
            }
        }

        private void button_MoveObjects_Click(object sender, EventArgs e)
        {
            if (comboBox_copyType.SelectedIndex == Const.SIMPLE_COPY_FILE)
            {
                SimpleCopyObjects();
            }
            else if(comboBox_copyType.SelectedIndex == Const.COPY_ROTATE_FILE)
            {
                AdvancedCopyObjects();
            }
            else
            {
                ImportComponents();
            }            
        }

        private void ImportComponents()
        {
            int startRow, endRow,  startColumn, endColumn;
            TS.Geometry3d.Vector offsetVector;

            double coeficientOfUnits = GetUnits();

            try
            {
                offsetVector = new TS.Geometry3d.Vector(Convert.ToDouble(textBox_dX.Text), Convert.ToDouble(textBox_dY.Text), Convert.ToDouble(textBox_dZ.Text));
            }
            catch (Exception ex)
            {
                MessageBox.Show("Special offset is not a numeric value.");
                return;
            }
            try
            {
                startRow = Convert.ToInt32(textBox_startRow.Text);
            }
            catch (Exception ex)
            {
                MessageBox.Show("Start Row is not a numeric value.");
                return;
            }
            try
            {
                endRow = Convert.ToInt32(textBox_endRow.Text);
            }
            catch (Exception ex)
            {
                MessageBox.Show("End Row is not a numeric value.");
                return;
            }
            try
            {
                startColumn = Convert.ToInt32(textBox_startColumn.Text);
                endColumn = Convert.ToInt32(textBox_endColumn.Text);
                if (endColumn < startColumn)
                {
                    MessageBox.Show("End column no. can't be lower then Start column no.");
                }
                else if (startColumn < 27)
                {
                    MessageBox.Show("Start column no. can't be lower then 27.");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("No. of columns is not a numeric value.");
                return;
            }            


            if (textBox_ExcelFile.Text == "")
                return;

            //get selected input objects
            ArrayList original_selected;
            original_selected = new ArrayList();

            GetAllObjectsIDs(true, ref original_selected);


            ArrayList ccpParameterTypes = new ArrayList();
            ArrayList moveDataFromFile = new ArrayList(); 

            if (textBox_ExcelFile.Text.Contains(".xlsx") || textBox_ExcelFile.Text.Contains(".xls"))
            {
                if (comboBox_sheets.Text == "")
                {
                    return;
                }
                moveDataFromFile = ReadFile.ReadExcelFileSheet(textBox_ExcelFile.Text, comboBox_sheets.SelectedIndex+1, startRow, endRow, startColumn, endColumn, Const.IMPORT_COMPONENTS_FILE, ccpParameterTypes);
            }
            else if (textBox_ExcelFile.Text.Contains(".txt"))
            {
                moveDataFromFile = ReadFile.ReadTextFile(textBox_ExcelFile.Text, startRow, endRow, 0, Const.IMPORT_COMPONENTS_FILE, ccpParameterTypes, '\t', ' ');                
            }
            else if (textBox_ExcelFile.Text.Contains(".csv"))
            {
                moveDataFromFile = ReadFile.ReadTextFile(textBox_ExcelFile.Text, startRow, endRow, 0, Const.IMPORT_COMPONENTS_FILE, ccpParameterTypes, ';');
            }




            //store original work plane
            TSM.WorkPlaneHandler wph = model.GetWorkPlaneHandler();
            TSM.TransformationPlane orig_trp = wph.GetCurrentTransformationPlane();
            TSM.TransformationPlane new_trp;

            //move object
            foreach (ExcelRow er in moveDataFromFile)
            {
                //create component
                double newX = ((er.newPoint.X * coeficientOfUnits) + offsetVector.X);
                double newY = ((er.newPoint.Y * coeficientOfUnits) + offsetVector.Y);
                double newZ = ((er.newPoint.Z * coeficientOfUnits) + offsetVector.Z);

                new_trp = new TSM.TransformationPlane(new TS.Geometry3d.Point(newX, newY, newZ), new TS.Geometry3d.Vector(1000, 0, 0), new TS.Geometry3d.Vector(0, 1000, 0));
                wph.SetCurrentTransformationPlane(new_trp);

                TSM.Component component = CreateComponent(er, ccpParameterTypes);

                if (component != null)
                {
                    ArrayList objectsToSelect = new ArrayList();
                    objectsToSelect.Add(component.Identifier.ID);
                    SelectParts(ref objectsToSelect);

                    //1 - rotate along z
                    double angle = er.phi * 0.9; //PHI converted from GON to DEG
                    angle = 90.0 - angle;

                    RotateSaveSmallAngles(angle, "x0");    

                    CsRotatePlaneZ(angle * Const.DEG_TO_RAD, ref wph);

                    //2 - rotate along x
                    new_trp = new TSM.TransformationPlane(new TS.Geometry3d.Point(0, 0, 0), new TS.Geometry3d.Vector(0, 1000, 0), new TS.Geometry3d.Vector(0, 0, 1000));
                    wph.SetCurrentTransformationPlane(new_trp);


                    angle = er.angle;

                    RotateSaveSmallAngles(angle, "x0");    

                    CsRotatePlaneX(angle * Const.DEG_TO_RAD, ref wph);

                    //set Z int Y
                    new_trp = new TSM.TransformationPlane(new TS.Geometry3d.Point(0, 0, 0), new TS.Geometry3d.Vector(0, 1000, 0), new TS.Geometry3d.Vector(0, 0, 1000));
                    wph.SetCurrentTransformationPlane(new_trp);


                    //3 - move rotate along Y axis with SLOPE degree
                    angle = Math.Atan(er.slope / 100.0);
                    angle = -angle * Const.RAD_TO_DEG;

                    RotateSaveSmallAngles(angle, "x0");                

                    wph.SetCurrentTransformationPlane(orig_trp);

                    //rename parts
                    if (comboBox_renameParts.SelectedIndex == 0)  //option Yes
                    {
                        RenameParts(ref objectsToSelect, er.newName);  //!!!in 14.1 it destroy rotation attribute for beam
                    }

                    model.CommitChanges();
                }

                wph.SetCurrentTransformationPlane(orig_trp);
            }

            //close opened windows
            akit.PushButton("dia_copy_cancel", "Copy");
            akit.PushButton("dia_move_rotate_cancel", "Move/rotate");

            akit.PushButton("dia_pa_cancel", "part_attrib");
            akit.PushButton("dia_pa_cancel", "diaConcreteBeam");
            akit.PushButton("dia_pa_cancel", "diaConcretePanel");

            SelectParts(ref original_selected);

            MessageBox.Show(this, "Macro finished successfully.");          
        }

        private TSM.Component CreateComponent(ExcelRow excelRow, ArrayList ccpParameterTypes)
        {
            Tekla.Structures.Model.Component C = new Tekla.Structures.Model.Component();
            C.Name = excelRow.ccpName;
            C.Number = -1;

            TSM.ComponentInput CI = new TSM.ComponentInput();
            CI.AddOneInputPosition(new Tekla.Structures.Geometry3d.Point(0, 0, 0));
            AddOneDirectionPosition(CI, comboBox_direction.SelectedIndex);

            C.SetComponentInput(CI);

            C.LoadAttributesFromFile(excelRow.ccpStandard);

            try
            {
                for (int i = 0; i < excelRow.ccpParameters.Count; i++)
                {
                    string parameter = excelRow.ccpParameters[i] as string;
                    CCPParamterType parameterType = ccpParameterTypes[i] as CCPParamterType;

                    switch (parameterType.type)
                    {
                        case Const.CCP_TYPE_STRING: C.SetAttribute(parameterType.name, parameter);
                            break;
                        case Const.CCP_TYPE_DOUBLE: C.SetAttribute(parameterType.name, ReadFile.GetDoubleFromString(parameter));
                            break;
                        case Const.CCP_TYPE_INT: C.SetAttribute(parameterType.name, ReadFile.GetIntFromString(parameter));
                            break;
                    }
                }
            }
            catch (Exception)
            {

            }

            if (!C.Insert())
            {
                MessageBox.Show("Import of a component failed!");
            }
            else
            {
                C.Modify();
            }

            return C;
        }

        private void AddOneDirectionPosition(TSM.ComponentInput CI, int direction)
        {
             switch(direction)
             {
                 case Const.DIR_P_Z: CI.AddOneInputPosition(new Tekla.Structures.Geometry3d.Point(0, 0, 1000));
                                break;
                 case Const.DIR_M_Z: CI.AddOneInputPosition(new Tekla.Structures.Geometry3d.Point(0, 0, -1000));
                                break;
                 case Const.DIR_P_X: CI.AddOneInputPosition(new Tekla.Structures.Geometry3d.Point(1000, 0, 0));
                                break;
                 case Const.DIR_M_X: CI.AddOneInputPosition(new Tekla.Structures.Geometry3d.Point(-1000, 0, 0));
                                break;
                 case Const.DIR_P_Y: CI.AddOneInputPosition(new Tekla.Structures.Geometry3d.Point(0, 1000, 0));
                                break;
                 case Const.DIR_M_Y: CI.AddOneInputPosition(new Tekla.Structures.Geometry3d.Point(0, -1000, 0));
                                break;
                default: break;    
             }
        }


        private void AdvancedCopyObjects()
        {
            //akit.Clear();
            int startRow, endRow;
            TS.Geometry3d.Vector offsetVector;

            double coeficientOfUnits = GetUnits();

            try
            {
                offsetVector = new TS.Geometry3d.Vector(Convert.ToDouble(textBox_dX.Text), Convert.ToDouble(textBox_dY.Text), Convert.ToDouble(textBox_dZ.Text));
            }
            catch (Exception ex)
            {
                MessageBox.Show("Special offset is not a numeric value.");
                return;
            }
            try{
                startRow=Convert.ToInt32(textBox_startRow.Text);
            }
            catch(Exception ex)
            {
                MessageBox.Show("Start Row is not a numeric value.");
                return;
            }
            try{
                endRow=Convert.ToInt32(textBox_endRow.Text);
            }
            catch(Exception ex)
            {
                MessageBox.Show("End Row is not a numeric value.");
                return;
            }


            if (textBox_ExcelFile.Text == "" )
                return;


            //get excel rows data
            ArrayList moveDataFromFile;
            moveDataFromFile = new ArrayList();

            if (textBox_ExcelFile.Text.Contains(".xlsx") || textBox_ExcelFile.Text.Contains(".xls"))
            {
                if (comboBox_sheets.Text == "")
                    return;
                moveDataFromFile = ReadFile.ReadExcelFileSheet(textBox_ExcelFile.Text, comboBox_sheets.SelectedIndex+1, startRow, endRow,0,0, Const.COPY_ROTATE_FILE,null);// 0 copy type 
            }
            else if (textBox_ExcelFile.Text.Contains(".txt"))
            {
                moveDataFromFile = ReadFile.ReadTextFile(textBox_ExcelFile.Text, startRow, endRow, 0, Const.COPY_ROTATE_FILE, null, '\t', ' ');                
            }
            else if (textBox_ExcelFile.Text.Contains(".csv"))
            {
                moveDataFromFile = ReadFile.ReadTextFile(textBox_ExcelFile.Text, startRow, endRow, 0, Const.COPY_ROTATE_FILE, null, ';');
            }

            //get selected input objects
            ArrayList original_selected;
            original_selected = new ArrayList();

            GetAllObjectsIDs(true, ref original_selected);

            if (original_selected.Count == 0)
            {
                MessageBox.Show("No model object selected.");
                return;
            }

 		    //store original work plane
            TSM.WorkPlaneHandler wph = model.GetWorkPlaneHandler();
            TSM.TransformationPlane orig_trp = wph.GetCurrentTransformationPlane();
            TSM.TransformationPlane new_trp;

            //move object
            for (int i = 0; i < moveDataFromFile.Count; i++)
            {
              

                ArrayList id_list1, id_list2, new_objects_id;
                id_list1 = new ArrayList();
                id_list2 = new ArrayList();
                new_objects_id = new ArrayList();


                //select(highlight) part selected by user
                SelectParts(ref original_selected);
                GetAllObjectsIDs(false, ref id_list1);
                ExcelRow er = moveDataFromFile[i] as ExcelRow;


                double newX = ((er.newPoint.X * coeficientOfUnits) + offsetVector.X);
                double newY = ((er.newPoint.Y * coeficientOfUnits) + offsetVector.Y);
                double newZ = ((er.newPoint.Z * coeficientOfUnits) + offsetVector.Z);
                //copy selected objects
                akit.CommandStart("ail_copy_translate", "", "main_frame");
                akit.ValueChange("Copy", "dx", newX.ToString());
                akit.ValueChange("Copy", "dy", newY.ToString());
                akit.ValueChange("Copy", "dz", newZ.ToString());
                HandleKeepDulicatesDialog();
                akit.PushButton("dia_copy_apply", "Copy");
                akit.CommandEnd();
                
                
                new_trp = new TSM.TransformationPlane(new TS.Geometry3d.Point(newX, newY, newZ), new TS.Geometry3d.Vector(1000, 0, 0), new TS.Geometry3d.Vector(0, 1000, 0));
                wph.SetCurrentTransformationPlane(new_trp);


                //get and select new objects
                GetAllObjectsIDs(false, ref id_list2);
                GetTwoArrayListsDiff(ref id_list1, ref id_list2, ref new_objects_id);
                SelectParts(ref new_objects_id);

                model.CommitChanges();

           
                //1 - rotate along z
                double angle = er.phi * 0.9; //PHI converted from GON to DEG
                angle = 90.0 - angle;

                RotateSaveSmallAngles(angle, "x0");

                CsRotatePlaneZ(angle * Const.DEG_TO_RAD, ref wph);

                //2 - rotate along x
                new_trp = new TSM.TransformationPlane(new TS.Geometry3d.Point(0, 0, 0), new TS.Geometry3d.Vector(0, 1000, 0), new TS.Geometry3d.Vector(0, 0, 1000));
                wph.SetCurrentTransformationPlane(new_trp);

                
                angle = er.angle;

                RotateSaveSmallAngles(angle, "x0");

                CsRotatePlaneX(angle * Const.DEG_TO_RAD, ref wph);

                //set Z int Y
                new_trp = new TSM.TransformationPlane(new TS.Geometry3d.Point(0, 0, 0), new TS.Geometry3d.Vector(0,1000, 0), new TS.Geometry3d.Vector(0, 0, 1000));
                wph.SetCurrentTransformationPlane(new_trp);
                               

                //3 - move rotate along Y axis with SLOPE degree
               
               
                angle = Math.Atan(er.slope / 100.0);
                angle = -angle * Const.RAD_TO_DEG;

                RotateSaveSmallAngles(angle, "x0");      

                wph.SetCurrentTransformationPlane(orig_trp);
            
                
                //rename parts
                if (comboBox_renameParts.SelectedIndex == 0)  //option Yes
                    RenameParts(ref new_objects_id, er.newName);  //!!!in 14.1 it destroy rotation attribute for beam


                model.CommitChanges();


                wph.SetCurrentTransformationPlane(orig_trp);

            }

            //show line & points
            if (comboBox_showLines.SelectedIndex == 0)  //option Yes
            {
                akit.CommandStart("ail_create_point_raster", "", "main_frame"); //create point dialog           
                for (int i = 0; i < moveDataFromFile.Count; i++)            
                {
                    ArrayList id_list1, id_list2, new_objects_id;
                    id_list1 = new ArrayList();
                    id_list2 = new ArrayList();
                    new_objects_id = new ArrayList();

                    //select(highlight) part selected by user
                    SelectParts(ref original_selected);
                    GetAllObjectsIDs(false, ref id_list1);
                    ExcelRow er = moveDataFromFile[i] as ExcelRow;

                    if (i > 0)
                        ShowLine(((ExcelRow)moveDataFromFile[i - 1]).newPoint, er.newPoint, offsetVector, coeficientOfUnits);

                    ShowPoint(er.newPoint, coeficientOfUnits);
                }
                akit.PushButton("dia_pr_cancel", "Point raster"); //create point dialog - close
                model.CommitChanges();
            }
          

            //close opened windows
            akit.PushButton("dia_copy_cancel", "Copy");
            akit.PushButton("dia_move_rotate_cancel", "Move/rotate");

            akit.PushButton("dia_pa_cancel", "part_attrib");
            akit.PushButton("dia_pa_cancel", "diaConcreteBeam");
            akit.PushButton("dia_pa_cancel", "diaConcretePanel");


            SelectParts(ref original_selected);

            MessageBox.Show(this, "Macro finished successfully.");
        }

          private void RotateSaveSmallAngles(double angle, string rotateString)
          {
            //if too small for rotating - add something bigger and then rotate that something back
            if (angle < Const.NUMBER_TOO_SMALL_FOR_ROTATING_CC && angle > -Const.NUMBER_TOO_SMALL_FOR_ROTATING_CC)
            {
                angle = angle + Const.NUMBER_TO_ADD_WHEN_ROTATING_CC;
                akit.CommandStart("ail_move_rotate", "", "main_frame");
                akit.ValueChange("Move/rotate", rotateString, "0.000000000000");
                akit.ValueChange("Move/rotate", "rot_angle", angle.ToString());
                HandleKeepDulicatesDialog();
                akit.PushButton("dia_move_rotate_apply", "Move/rotate");
                akit.CommandEnd();

                model.CommitChanges();

                angle = -Const.NUMBER_TO_ADD_WHEN_ROTATING_CC;
                akit.CommandStart("ail_move_rotate", "", "main_frame");
                akit.ValueChange("Move/rotate", rotateString, "0.000000000000");
                akit.ValueChange("Move/rotate", "rot_angle", angle.ToString());
                HandleKeepDulicatesDialog();
                akit.PushButton("dia_move_rotate_apply", "Move/rotate");
                akit.CommandEnd();

                model.CommitChanges();
            }
            else
            {
                akit.CommandStart("ail_move_rotate", "", "main_frame");
                akit.ValueChange("Move/rotate", rotateString, "0.000000000000");
                akit.ValueChange("Move/rotate", "rot_angle", angle.ToString());
                HandleKeepDulicatesDialog();
                akit.PushButton("dia_move_rotate_apply", "Move/rotate");
                akit.CommandEnd();

                model.CommitChanges();
            }
        }


        private void button_Cancel_Click(object sender, EventArgs e)
        {
		    Application.Exit();
        }

        private void openFileDialog1_FileOk(object sender, CancelEventArgs e)
        {
		 
        }

        private void button_OpenFile_Click(object sender, EventArgs e)
        {
    		OpenFileDialog dlg1 = new OpenFileDialog();
	        dlg1.InitialDirectory = "c:\\" ;

            dlg1.Filter = "Excel files (*.xls;*.xlsx)|*.xls;*.xlsx|Text files (*.txt)|*.txt|CSV files (*.csv)|*.csv||";
            dlg1.FilterIndex = 1;
		    dlg1.RestoreDirectory = true;

            if (dlg1.ShowDialog() == DialogResult.OK) 
            {

                textBox_ExcelFile.Text = dlg1.FileName;
                if (textBox_ExcelFile.Text.Contains(".xlsx") || textBox_ExcelFile.Text.Contains(".xls"))
                     FillComboboxWithSheetsNames(ref textBox_ExcelFile, ref comboBox_sheets);

		    }
        }

   
        private void textBox_dX_KeyPress(object sender, KeyPressEventArgs e)
        {
            originalText = textBox_dX.Text; 
        }

        private void textBox_dY_KeyPress(object sender, KeyPressEventArgs e)
        {
            originalText = textBox_dY.Text; 
        }

        private void textBox_dZ_KeyPress(object sender, KeyPressEventArgs e)
        {
            originalText = textBox_dZ.Text; 
        }

        private void textBox_endRow_KeyPress(object sender, KeyPressEventArgs e)
        {
            TextBoxNumberFormatInt(e, textBox_endRow.Text);
        }

        private void textBox_startRow_KeyPress(object sender, KeyPressEventArgs e)
        {
            TextBoxNumberFormatInt(e, textBox_startRow.Text);
        }

        private void textBox_dX_TextChanged(object sender, EventArgs e)
        {
            //TextBoxNumberFormatDouble(textBox_dX.Text);
            double isNumber;
            textBox_dX.Text = textBox_dX.Text.Replace(",", "");
            if (!double.TryParse(textBox_dX.Text, out isNumber) && textBox_dX.Text != "")
                textBox_dX.Text = originalText; 
        }

        private void textBox_dY_TextChanged(object sender, EventArgs e)
        {
           //TextBoxNumberFormatDouble(textBox_dY.Text);
            double isNumber;
            textBox_dY.Text = textBox_dY.Text.Replace(",", "");
            if (!double.TryParse(textBox_dY.Text, out isNumber) && textBox_dY.Text != "")
                textBox_dY.Text = originalText;

        }

        private void textBox_dZ_TextChanged(object sender, EventArgs e)
        {
            //TextBoxNumberFormatDouble(textBox_dZ.Text);
            double isNumber;
            textBox_dZ.Text = textBox_dZ.Text.Replace(",", "");
            if (!double.TryParse(textBox_dZ.Text, out isNumber) && textBox_dZ.Text != "")
                textBox_dZ.Text = originalText;
            
        }

      /*  private void TextBoxNumberFormatDouble( string textBoxText)
        {
            double isNumber;
            string textBoxText = textBox_dX.Text + "0"; // "0" - to allow "."(point) 
            textBox_dY.Text = text;

            if (!double.TryParse(textBoxText, out isNumber))
                textBox_dX.Text = originalText; 
        }*/

        private void TextBoxNumberFormatInt(KeyPressEventArgs e, string textBoxText)
        {
            int isNumber = 0;
            string text = textBoxText + e.KeyChar.ToString(); // "0" - to allow "."(point) 
            text = text.Replace("\b", ""); //remove backspace character
            e.Handled = !int.TryParse(text, out isNumber);
        }

        private void ShowLine(TS.Geometry3d.Point startPoint, TS.Geometry3d.Point endPoint, TS.Geometry3d.Vector offsetVector, double coeficientOfUnits)
        {
            // TS.Geometry3d.LineSegment ls = new TS.Geometry3d.LineSegment(new TSG.Point(0, 0, 2000), new TSG.Point(0, 0, 2000));
          
            TSM.UI.GraphicsDrawer gd = new TSM.UI.GraphicsDrawer();
            TSM.UI.Color clr = new TSM.UI.Color(1, 0, 0);
            gd.DrawLineSegment(new TS.Geometry3d.Point(startPoint.X * coeficientOfUnits, startPoint.Y * coeficientOfUnits, startPoint.Z * coeficientOfUnits), new TS.Geometry3d.Point(endPoint.X * coeficientOfUnits, endPoint.Y * coeficientOfUnits, endPoint.Z * coeficientOfUnits), clr);
        }

        private void ShowPoint(TS.Geometry3d.Point p, double coeficientOfUnits)
        {
            akit.ValueChange("Point raster", "dia_pr_xdist", (p.X * coeficientOfUnits).ToString());
            akit.ValueChange("Point raster", "dia_pr_ydist", (p.Y * coeficientOfUnits).ToString());
            akit.ValueChange("Point raster", "dia_pr_zcoord", (p.Z * coeficientOfUnits).ToString());
            akit.PushButton("dia_pr_apply", "Point raster");
        }

        private void textBox_dX_Validated(object sender, EventArgs e)
        {
            if (textBox_dX.Text == "") textBox_dX.Text = "0.0";
        }

        private void textBox_dY_Validated(object sender, EventArgs e)
        {
            if (textBox_dY.Text == "") textBox_dY.Text = "0.0";
        }

        private void textBox_dZ_Validated(object sender, EventArgs e)
        {
            if (textBox_dZ.Text == "") textBox_dZ.Text = "0.0";
        }

        private void HandleKeepDulicatesDialog()
        {
            if (comboBox_duplicates.SelectedIndex != Const.SHOW_DUPLICATES_DIALOG_AND_ASK)
                akit.ModalDialog(comboBox_duplicates.SelectedIndex);
        }

    }


    public class ReadFile
    {
        public ReadFile()
        {
        }


        public static ArrayList ReadSheetsNames(string path)
        {
            

            ArrayList table_names = new ArrayList();

            EXCEL.Application xlApp = new EXCEL.Application();

            if (xlApp == null)
            {
                MessageBox.Show("Excel could not be started. Check that your office installation and project references are correct.");
            }
            else
            {
                xlApp.Visible = false; 
                

                try
                {
                    if (xlApp.Version == "11.0" && path.Contains(".xlsx"))  //office 2003 and new format xlsx
                    {
                        MessageBox.Show("Cannot open *.xlsx file, please convert it into *.xls");

                        return table_names;
                    }

                    EXCEL.Workbook workBookIn = xlApp.Workbooks.Open(path, 0, true, 5,
                        "", "", true, Excel.XlPlatform.xlWindows, "\t", false, false, 0, true);

                    if (workBookIn != null)
                    {
                        //get all sheets name
                        int numSheets = workBookIn.Sheets.Count;

                        for (int sheetNum = 1; sheetNum < numSheets + 1; sheetNum++)
                        {
                            EXCEL.Worksheet sheet = (EXCEL.Worksheet)workBookIn.Worksheets[sheetNum];

                            table_names.Add(sheet.Name);
                        }
                        workBookIn.Close(false, path, null);
                    }
                }
                catch
                {
                    MessageBox.Show("Cannot open file: " + path);
                }
            }

            return table_names;
        }

        public static ArrayList ReadExcelFileSheet(string path, int spreadSheetIndex, int firstRow, int lastRow, int firstColumn, int lastColumn, int copyType, ArrayList ccpParameterTypes)
        {
            ArrayList rowList = new ArrayList();

            int copyOffset = 0;
            int rowNo = Const.HEAD_ROW_NO;
            List<string> paramStringNames = new List<string>();
            List<string> paramIntNames = new List<string>();
            List<string> paramDoubleNames = new List<string>();
                  
            //for advanced and import component
            if (copyType == Const.SIMPLE_COPY_FILE)
            {
                copyOffset = 1;
            }
            else if(copyType == Const.IMPORT_COMPONENTS_FILE)
            {
                ReadComponentParamOptions(ref paramStringNames, ref paramIntNames, ref paramDoubleNames, '\t', ' ');
            }

            EXCEL.Application xlApp = new EXCEL.Application();

            if (xlApp == null)
            {
                MessageBox.Show("Excel could not be started. Check that your office installation and project references are correct.");
            }
            else
            {
                xlApp.Visible = false;

                //!!! if there is no office 2007 installed this fail
                try
                {
                    if (xlApp.Version == "11.0" && path.Contains(".xlsx"))  //office 2003 and new format xlsx
                    {
                        return rowList;
                    }

                    EXCEL.Workbook workBookIn = xlApp.Workbooks.Open(path, 0, true, 5,
                            "", "", true, Excel.XlPlatform.xlWindows, "\t", false, false, 0, true);

                    if (workBookIn != null)
                    {
                        //open selected sheet

                        EXCEL.Worksheet sheet = (EXCEL.Worksheet)workBookIn.Worksheets[spreadSheetIndex];

                        // sheet.Name;
                        if (sheet != null)
                        {

                            try
                            {
                                while (rowNo <= lastRow)
                                {
                                    Excel.Range cellRange;
                                    //read headlines for CCP parameters 
                                    if (rowNo == Const.HEAD_ROW_NO && copyType == Const.IMPORT_COMPONENTS_FILE)
                                    {
                                        for (int columnNo = firstColumn+2; columnNo <= lastColumn; columnNo++)
                                        {
                                            cellRange = (EXCEL.Range)sheet.Cells[rowNo, columnNo];
                                            if (cellRange.Text.ToString() != "")
                                            {
                                                CCPParamterType parameterType = new CCPParamterType();
                                                parameterType.name = cellRange.Text.ToString();
                                                ccpParameterTypes.Add(parameterType);
                                            }
                                        }
                                    }
                                    else if (rowNo == Const.DATA_TYPE_ROW_NO && copyType == Const.IMPORT_COMPONENTS_FILE)
                                    {

                                        for (int columnNo = firstColumn+2; columnNo <= lastColumn; columnNo++)
                                        {
                                            cellRange = (EXCEL.Range)sheet.Cells[rowNo, columnNo];
                                            if (cellRange.Text.ToString() != "")
                                            {
                                                int parameterNo = columnNo - (firstColumn+2);

                                                if (ccpParameterTypes.Count > parameterNo)
                                                {
                                                    (ccpParameterTypes[parameterNo] as CCPParamterType).type = GetCCPParameterType(cellRange.Text.ToString(), paramStringNames, paramIntNames, paramDoubleNames);
                                                }
                                            }

                                        }

                                    }

                                    if (rowNo >= firstRow && rowNo <= lastRow)
                                    {
                                        ExcelRow newRow = new ExcelRow();

                                        Excel.Range cellRange1, cellRange2, cellRange3;

                                        cellRange1 = (EXCEL.Range)sheet.Cells[rowNo, 3 - copyOffset];
                                        cellRange2 = (EXCEL.Range)sheet.Cells[rowNo, 4 - copyOffset];
                                        cellRange3 = (EXCEL.Range)sheet.Cells[rowNo, 5 - copyOffset];

                                        if (cellRange1.Text.ToString() == "" && cellRange2.Text.ToString() == "" && cellRange3.Text.ToString() == "")
                                            break;

                                        if (cellRange1.Text.ToString() != "")
                                            newRow.newPoint.X = GetDoubleFromString(cellRange1.Text.ToString());
                                        if (cellRange2.Text.ToString() != "")
                                            newRow.newPoint.Y = GetDoubleFromString(cellRange2.Text.ToString());
                                        if (cellRange3.Text.ToString() != "")
                                            newRow.newPoint.Z = GetDoubleFromString(cellRange3.Text.ToString());

                                        if (copyType != 1)  //if not simple reading do next
                                        {
                                            cellRange = (EXCEL.Range)sheet.Cells[rowNo, 6];
                                            if (cellRange.Text.ToString() != "")
                                                newRow.phi = GetDoubleFromString(cellRange.Text.ToString());
                                            cellRange = (EXCEL.Range)sheet.Cells[rowNo, 9];
                                            if (cellRange.Text.ToString() != "")
                                                newRow.angle = GetDoubleFromString(cellRange.Text.ToString());
                                            cellRange = (EXCEL.Range)sheet.Cells[rowNo, 10];
                                            if (cellRange.Text.ToString() != "")
                                                newRow.slope = GetDoubleFromString(cellRange.Text.ToString());
                                            cellRange = (EXCEL.Range)sheet.Cells[rowNo, 11];
                                            if (cellRange.Text.ToString() != "")
                                                newRow.moveType = cellRange.Text.ToString();
                                            cellRange = (EXCEL.Range)sheet.Cells[rowNo, 26];
                                            if (cellRange.Text.ToString() != "")
                                                newRow.newName = cellRange.Text.ToString();

                                            if (copyType == 2)
                                            {
                                                cellRange = (EXCEL.Range)sheet.Cells[rowNo, firstColumn];
                                                if (cellRange.Text.ToString() != "")
                                                    newRow.ccpName = cellRange.Text.ToString();

                                                cellRange = (EXCEL.Range)sheet.Cells[rowNo, firstColumn +1];
                                                if (cellRange.Text.ToString() != "")
                                                    newRow.ccpStandard = cellRange.Text.ToString();

                                                for (int columnNo = firstColumn + 2; columnNo <= lastColumn; columnNo++)
                                                {
                                                    cellRange = (EXCEL.Range)sheet.Cells[rowNo, columnNo];
                                                    if (cellRange.Text.ToString() != "")
                                                        newRow.ccpParameters.Add(cellRange.Text.ToString());
                                                }
                                            }
                                        }
                                        else if (copyType == 1) //rename for simple reading 
                                        {
                                            cellRange = (EXCEL.Range)sheet.Cells[rowNo, 6 - copyOffset];
                                            if (cellRange.Text.ToString() != "")
                                                newRow.newName = cellRange.Text.ToString();
                                        }

                                        rowList.Add(newRow);
                                    }

                                    rowNo++;
                                }
                            }
                            catch (Exception ex)
                            {
                                MessageBox.Show(ex.ToString());
                            }
                            finally
                            {
                                workBookIn.Close(false, path, null);
                            }
                        }
                    }
                }
                catch
                {
                    MessageBox.Show("Cannot open file: " + path);
                }
            }

            return rowList;
        }




        //public static ArrayList ReadExcelFileSheet(string path, string spreadsheet, decimal firstRow, decimal lastRow, decimal noOfCCPParams, int copyType, ArrayList ccpParameterTypes)
        //{
        //    ArrayList rowList = new ArrayList();

        //    int copyOffset = 0;
        //    int rowNo = Const.HEAD_ROW_NO;

        //    //for advanced and import component
        //    if (copyType == Const.SIMPLE_COPY_FILE)
        //    {
        //        copyOffset = 1;
        //    }

        //    EXCEL.Application xlApp = new EXCEL.Application();

        //    if (xlApp == null)
        //    {
        //        MessageBox.Show("Excel could not be started. Check that your office installation and project references are correct.");
        //    }
        //    else
        //    {

        //        xlApp.Visible = false;
                
        //        //!!! if there is no office 2007 installed this fail
        //        try
        //        {
        //            if (xlApp.Version == "11.0" && path.Contains(".xlsx"))  //office 2003 and new format xlsx
        //            {
        //                return rowList;
        //            }

        //            EXCEL.Workbook workBookIn = xlApp.Workbooks.Open(path, 0, true, 5,
        //                    "", "", true, Excel.XlPlatform.xlWindows, "\t", false, false, 0, true);

        //            if (workBookIn != null)
        //            {
        //                //open selected sheet

        //                EXCEL.Worksheet sheet = (EXCEL.Worksheet)workBookIn.Worksheets[spreadSheetIndex];

        //                // sheet.Name;
        //                if (sheet != null)
        //                {

        //                    try
        //                    {
        //                        while (rowNo <= lastRow)
        //                        {
        //                            if (rowNo >= firstRow && rowNo <= lastRow)
        //                            {

        //                                ExcelRow newRow = new ExcelRow();

        //                foreach (object cellContent in cells)
        //                {
        //                    //read headlines for CCP parameters 
        //                    if (rowNo == Const.HEAD_ROW_NO && copyType == Const.IMPORT_COMPONENTS_FILE && columnNo + copyOffset >= Const.FIRST_PARAMETER_COLUMN)
        //                    {
        //                        cellText = cellContent.ToString();
        //                        cellText = cellText.Replace("\n", "|");

        //                        if (cellText != "")
        //                        {
        //                            CCPParamterType parameterType = new CCPParamterType();
        //                            parameterType.name = cellText;
        //                            ccpParameterTypes.Add(parameterType);
        //                        }
        //                    }
        //                    else if (rowNo == Const.DATA_TYPE_ROW_NO && copyType == Const.IMPORT_COMPONENTS_FILE && columnNo + copyOffset >= Const.FIRST_PARAMETER_COLUMN)
        //                    {
        //                        cellText = cellContent.ToString();
        //                        cellText = cellText.Replace("\n", "|");

        //                        if (cellText != "")
        //                        {
        //                            int parameterNo = columnNo + copyOffset - Const.FIRST_PARAMETER_COLUMN;

        //                            if (ccpParameterTypes.Count > parameterNo)
        //                            {
        //                                (ccpParameterTypes[parameterNo] as CCPParamterType).type = GetCCPParameterType(cellText);
        //                            }
        //                        }
        //                    }
        //                    //else 
        //                    if (rowNo >= firstRow && rowNo <= lastRow)
        //                    {
        //                        //Convert object cellContect into String to read whilst replacing Line Breaks with a defined character
        //                        cellText = cellContent.ToString();
        //                        cellText = cellText.Replace("\n", "|");

        //                        if (cellText != "")
        //                        {
        //                            try
        //                            {
        //                                if ((copyType == Const.SIMPLE_COPY_FILE && columnNo < 5) //SIPLE_FILE HAS JUST 4 COLUMNS
        //                                    || (copyType == Const.COPY_ROTATE_FILE && columnNo + copyOffset < 26) //advanced just 25
        //                                    || (copyType == Const.IMPORT_COMPONENTS_FILE)) //26...settings for ccp
        //                                {
        //                                    switch (columnNo + copyOffset)
        //                                    {
        //                                        case 2: newRow.newPoint.X = GetDoubleFromString(cellText);
        //                                            break;
        //                                        case 3: newRow.newPoint.Y = GetDoubleFromString(cellText);
        //                                            break;
        //                                        case 4: newRow.newPoint.Z = GetDoubleFromString(cellText);
        //                                            break;
        //                                        case 5: if (copyType == 0 || copyType == 2)
        //                                                newRow.phi = GetDoubleFromString(cellText);
        //                                            else if (copyType == 1)
        //                                                newRow.newName = cellText;
        //                                            break;
        //                                        case 8: newRow.angle = GetDoubleFromString(cellText);
        //                                            break;
        //                                        case 9: newRow.slope = GetDoubleFromString(cellText);
        //                                            break;
        //                                        case 10: newRow.moveType = cellText;
        //                                            break;
        //                                        case 25: newRow.newName = cellText;  //10 and 25 are neighbours
        //                                            break;
        //                                        case 26: newRow.ccpName = cellText;
        //                                            break;
        //                                        case 27: newRow.ccpStandard = cellText;
        //                                            break;
        //                                        default:
        //                                            if (columnNo + copyOffset >= Const.FIRST_PARAMETER_COLUMN //where to start
        //                                                && columnNo + copyOffset < Const.FIRST_PARAMETER_COLUMN + noOfCCPParams) //no of parameters
        //                                            {
        //                                                newRow.ccpParameters.Add(cellText);
        //                                            }
        //                                            break;
        //                                    }
        //                                }
        //                            }
        //                            catch (Exception e)
        //                            {
        //                                columnNo = columnNo - 1;
        //                                rowNo = rowNo - 1;
        //                                MessageBox.Show("Wrong input format. Cell: (" + rowNo + "," + columnNo + ")");
        //                            }
        //                        }


        //                    }
        //                    columnNo++;
        //                }

        //                if (rowNo >= firstRow && newRow != null)
        //                {
        //                    rowList.Add(newRow);
        //                    //MessageBox.Show(newRow.newPoint.X.ToString() + "  " + newRow.newPoint.Y.ToString() + "  " + newRow.newPoint.Z.ToString() + "  " + newRow.phi.ToString() + "  " + newRow.angle.ToString() + "  " + newRow.slope.ToString() + "  " + newRow.moveType);
        //                }

        //                rowNo++;

        //                if (rowNo > lastRow)
        //                {
        //                    break;
        //                }
        //            }
        //        }
        //        catch (Exception ex)
        //        {
        //            MessageBox.Show(ex.ToString());
        //        }
        //        finally
        //        {
        //            con.Close();
        //        }

        //    }
        //    catch (Exception)
        //    {
        //    }
        //    return rowList;
        //}



        private static string RemoveMoreSpaces(ref string str)
        {
            int i = 0;
            str = str.Trim();
            while (i < str.Length - 1)
            {
                if (str.Substring(i, 2) == "  ")
                    str = str.Remove(i, 1);
                else
                    i++;
            }

            return str;
        }

        private static string RemoveMoreTabelators(ref string str)
        {
            int i = 0;
            while (i < str.Length - 1)
            {
                if (str.Substring(i, 2) == "\t\t")
                    str = str.Remove(i, 1);
                else
                    i++;
            }

            return str;
        }

        public static int SetEnglishCultureInfo() //conversion of double to string comma to point
        {
            System.Globalization.CultureInfo ci = new CultureInfo("en-US", false);
            Thread.CurrentThread.CurrentCulture = ci;
            return 1;
        }

        public static int SetCzechCultureInfo() //conversion of double to string comma to point
        {
            System.Globalization.CultureInfo ci = new CultureInfo("cs-CZ", false);
            Thread.CurrentThread.CurrentCulture = ci;
            return 1;
        }

        public static double GetDoubleFromString(string str) //conversion of double to string comma to point -culture info
        {
            return Convert.ToDouble(str.Replace(',', '.'), CultureInfo.InvariantCulture);
        }

        public static double GetIntFromString(string str) //conversion of double to string comma to point -culture info
        {
            return Convert.ToInt32(str.Replace(',', '.'));
        }


        public static int GetCCPParameterType(string cellText, List<string> paramStringNames, List<string> paramIntNames, List<string> paramDoubleNames)
        {
            int type = Const.CCP_NO_TYPE;

            if (paramStringNames.Contains(cellText))
            {
                type = Const.CCP_TYPE_STRING;
            }
            else if (paramDoubleNames.Contains(cellText))
            {
                type = Const.CCP_TYPE_DOUBLE;
            }
            else if (paramIntNames.Contains(cellText))
            {
                type = Const.CCP_TYPE_INT;
            }

            return type;
        }

        /*
           public static ArrayList ReadExcelFileSheet(string path, string spreadsheet, decimal firstRow, decimal lastRow,decimal noOfCCPParams, int copyType, ArrayList ccpParameterTypes)
        {
            ArrayList rowList = new ArrayList();

            int copyOffset = 0;
            int rowNo = Const.HEAD_ROW_NO;

            //for advanced and import component
            if (copyType == Const.SIMPLE_COPY_FILE)
            {
                copyOffset = 1;
            }

            try
            {
                string ConnectionString = "", cellText = "";

                if (path.Contains(".xlsx"))
                    ConnectionString = @"Provider=Microsoft.ACE.OLEDB.12.0;Data Source=" + path + @"; Extended Properties=""Excel 12.0;HDR=No;IMEX=1"";";
                else
                    ConnectionString = @"Provider=Microsoft.Jet.OLEDB.4.0; Data Source=" + path + @"; Extended Properties=""Excel 8.0;HDR=No;IMEX=1"";";

                //"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\test.xls;Extended Properties=Excel 8.0"

                OleDbConnection con = new OleDbConnection(ConnectionString);
                con.Open();

                try
                {
                    //Create Dataset and fill with imformation from the Excel Spreadsheet for easier reference
                    DataSet myDataSet = new DataSet();
                    //OleDbDataAdapter myCommand = new OleDbDataAdapter(" SELECT * FROM [" + spreadsheet + "$]", con);
                    OleDbDataAdapter myCommand = new OleDbDataAdapter(" SELECT * FROM [" + spreadsheet + "]", con);
                    myCommand.Fill(myDataSet);
                    con.Close();

                    //Travers through each row in the dataset
                    foreach (DataRow myDataRow in myDataSet.Tables[0].Rows)
                    {
                        //Stores info in Datarow into an array
                        System.Object[] cells = myDataRow.ItemArray;
                        //Traverse through each array and put into object cellContent as type Object
                        //Using Object as for some reason the Dataset reads some blank value which
                        //causes a hissy fit when trying to read. By using object I can convert to
                        //String at a later point.
                        int columnNo = 0;
                        ExcelRow newRow = new ExcelRow();
                        foreach (object cellContent in cells)
                        {
                            //read headlines for CCP parameters 
                            if (rowNo == Const.HEAD_ROW_NO && copyType == Const.IMPORT_COMPONENTS_FILE && columnNo + copyOffset >= Const.FIRST_PARAMETER_COLUMN)
                            {
                                cellText = cellContent.ToString();
                                cellText = cellText.Replace("\n", "|");

                                if (cellText != "")
                                {
                                    CCPParamterType parameterType = new CCPParamterType();
                                    parameterType.name = cellText;
                                    ccpParameterTypes.Add(parameterType);
                                }
                            }
                            else if (rowNo == Const.DATA_TYPE_ROW_NO && copyType == Const.IMPORT_COMPONENTS_FILE && columnNo + copyOffset >= Const.FIRST_PARAMETER_COLUMN)
                            {
                                cellText = cellContent.ToString();
                                cellText = cellText.Replace("\n", "|");

                                if (cellText != "")
                                {
                                    int parameterNo = columnNo + copyOffset - Const.FIRST_PARAMETER_COLUMN;

                                    if (ccpParameterTypes.Count > parameterNo)
                                    {
                                        (ccpParameterTypes[parameterNo] as CCPParamterType).type = GetCCPParameterType(cellText);
                                    }
                                }
                            }
                            //else 
                            if (rowNo >= firstRow && rowNo <= lastRow)
                            {
                                //Convert object cellContect into String to read whilst replacing Line Breaks with a defined character
                                cellText = cellContent.ToString();
                                cellText = cellText.Replace("\n", "|");

                                if (cellText != "")
                                {
                                    try
                                    {
                                        if ((copyType == Const.SIMPLE_COPY_FILE && columnNo < 5) //SIPLE_FILE HAS JUST 4 COLUMNS
                                            || (copyType == Const.COPY_ROTATE_FILE && columnNo + copyOffset < 26) //advanced just 25
                                            || (copyType == Const.IMPORT_COMPONENTS_FILE)) //26...settings for ccp
                                        {
                                            switch (columnNo + copyOffset)
                                            {
                                                case 2: newRow.newPoint.X = GetDoubleFromString(cellText);
                                                    break;
                                                case 3: newRow.newPoint.Y = GetDoubleFromString(cellText);
                                                    break;
                                                case 4: newRow.newPoint.Z = GetDoubleFromString(cellText);
                                                    break;
                                                case 5: if (copyType == 0 || copyType == 2)
                                                        newRow.phi = GetDoubleFromString(cellText);
                                                    else if (copyType == 1)
                                                        newRow.newName = cellText;
                                                    break;
                                                case 8: newRow.angle = GetDoubleFromString(cellText);
                                                    break;
                                                case 9: newRow.slope = GetDoubleFromString(cellText);
                                                    break;
                                                case 10: newRow.moveType = cellText;
                                                    break;
                                                case 25: newRow.newName = cellText;  //10 and 25 are neighbours
                                                    break;
                                                case 26: newRow.ccpName = cellText;
                                                    break;
                                                case 27: newRow.ccpStandard = cellText;
                                                    break;
                                                default:
                                                    if (columnNo + copyOffset >= Const.FIRST_PARAMETER_COLUMN //where to start
                                                        && columnNo + copyOffset < Const.FIRST_PARAMETER_COLUMN + noOfCCPParams) //no of parameters
                                                    {
                                                        newRow.ccpParameters.Add(cellText);
                                                    }
                                                    break;
                                            }
                                        }
                                    }
                                    catch (Exception e)
                                    {
                                        columnNo = columnNo - 1;
                                        rowNo = rowNo - 1;
                                        MessageBox.Show("Wrong input format. Cell: (" + rowNo + "," + columnNo + ")");
                                    }
                                }


                            }
                            columnNo++;
                        }

                        if (rowNo >= firstRow && newRow != null)
                        {
                            rowList.Add(newRow);
                            //MessageBox.Show(newRow.newPoint.X.ToString() + "  " + newRow.newPoint.Y.ToString() + "  " + newRow.newPoint.Z.ToString() + "  " + newRow.phi.ToString() + "  " + newRow.angle.ToString() + "  " + newRow.slope.ToString() + "  " + newRow.moveType);
                        }

                        rowNo++;

                        if (rowNo > lastRow)
                        {
                            break;
                        }
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
                finally
                {
                    con.Close();
                }

            }
            catch (Exception)
            {
            }
            return rowList;
        } 
         
        */
        public static void ReadComponentParamOptions(ref List<string> paramStringNames, ref List<string> paramIntNames, ref List<string> paramDoubleNames, params char[] separators)
        {
            StreamReader SR;
            string rowString;

            try
            {

                //string path = "";
                //TS.TeklaStructuresSettings.GetAdvancedOption("XS_MACRO_DIRECTORY", ref path);

                string applicationDirectory = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase);
                string path = System.IO.Path.Combine(applicationDirectory, "CS Copy Objects (ML004) Options.ini");

                path = path.Substring(6);

               // MessageBox.Show(path);
                SR = File.OpenText(path);

                if (SR != null)
                {
                    rowString = SR.ReadLine();

                    while (rowString != null)
                    {
                        List<string> rowStringList = new List<string>();
                        rowString = RemoveMoreSpaces(ref rowString);
                        rowString = RemoveMoreTabelators(ref rowString);
                        string[] rowSeperatedStrings;

                        if (rowString.Length != 0)
                        {
                            rowSeperatedStrings = rowString.Split(separators);

                            string type = rowSeperatedStrings[1];
                            type = type.Replace("\n", "|");

                            string value = rowSeperatedStrings[0];
                            value = value.Replace("\n", "|");

                            switch (type)
                            {
                                case Const.CCP_TYPE_STRING_STR: paramStringNames.Add(value);
                                    break;
                                case Const.CCP_TYPE_DOUBLE_STR: paramDoubleNames.Add(value);
                                    break;
                                case Const.CCP_TYPE_INT_STR: paramIntNames.Add(value);
                                    break;
                            }

                        }                 
                        rowString = SR.ReadLine();
                    }
                }
                SR.Close();
            }
            catch (Exception e)
            {
                MessageBox.Show("Ini file could not be read.");
            }
        }

        public static ArrayList ReadTextFile(string path, decimal firstRow, decimal lastRow, decimal noOfCCPParams, int copyType, ArrayList ccpParameterTypes, params char[] separators)
        {
            ArrayList rowList = new ArrayList();
            int rowNo = 0, copyOffset = 0; //skips first line some how
            bool wrongFile = false;

            if (copyType == Const.SIMPLE_COPY_FILE)
            {
                copyOffset = 1;
            }

            //open file
            StreamReader SR;
            string rowString;

            try
            {
                SR = File.OpenText(path);

                if (SR != null)
                {
                    rowString = SR.ReadLine();

                    while (rowString != null)
                    {
                        ExcelRow newRow = new ExcelRow();

                        //if (rowNo >= firstRow)
                        //{
                            List<string> rowStringList = new List<string>();
                            rowString = RemoveMoreSpaces(ref rowString);
                            rowString = RemoveMoreTabelators(ref rowString);
                            string[] rowSeperatedStrings;

                            if (rowString.Length != 0)
                            {

                                //char[] separators = new char[2];
                                //separators[0] = '\t';//table copied from excel
                                //separators[1] = ' ';

                                rowSeperatedStrings = rowString.Split(separators);

                                for (int columnNo = 0; columnNo < rowSeperatedStrings.Length; columnNo++)
                                {
                                    try
                                    {
                                        ////read headlines for CCP parameters 
                                        //if (rowNo == Const.HEAD_ROW_NO && copyType == Const.IMPORT_COMPONENTS_FILE && columnNo + copyOffset >= Const.FIRST_PARAMETER_COLUMN)
                                        //{
                                        //    string cellText = rowSeperatedStrings[columnNo];
                                        //    cellText = cellText.Replace("\n", "|");

                                        //    if (cellText != "")
                                        //    {
                                        //        CCPParamterType parameterType = new CCPParamterType();
                                        //        parameterType.name = cellText;
                                        //        ccpParameterTypes.Add(parameterType);
                                        //    }
                                        //}
                     

                                        //if (rowNo == Const.DATA_TYPE_ROW_NO && copyType == Const.IMPORT_COMPONENTS_FILE && columnNo + copyOffset >= Const.FIRST_PARAMETER_COLUMN)
                                        //{
                                        //    string cellText = rowSeperatedStrings[columnNo];
                                        //    cellText = cellText.Replace("\n", "|");

                                        //    if (cellText != "")
                                        //    {
                                        //        int parameterNo = columnNo + copyOffset - Const.FIRST_PARAMETER_COLUMN;

                                        //        if (ccpParameterTypes.Count > parameterNo)
                                        //        {
                                        //            (ccpParameterTypes[parameterNo] as CCPParamterType).type = GetCCPParameterType(cellText);
                                        //        }
                                        //    }
                                        //}




                                        if (rowNo >= firstRow &&((copyType == Const.SIMPLE_COPY_FILE && columnNo < 5) //SIPLE_FILE HAS JUST 4 COLUMNS
                                          || (copyType == Const.COPY_ROTATE_FILE && columnNo + copyOffset < 13) //advanced just 25
                                          || (copyType == Const.IMPORT_COMPONENTS_FILE))) //26...settings for ccp
                                        {
                                            switch (columnNo + copyOffset)
                                            {
                                              
                                                case 2: newRow.newPoint.X = GetDoubleFromString(rowSeperatedStrings[columnNo]);
                                                    break;
                                                case 3: newRow.newPoint.Y = GetDoubleFromString(rowSeperatedStrings[columnNo]);
                                                    break;
                                                case 4: newRow.newPoint.Z = GetDoubleFromString(rowSeperatedStrings[columnNo]);
                                                    break;
                                                case 5: if (copyType == 0 || copyType == 2)
                                                        newRow.phi = GetDoubleFromString(rowSeperatedStrings[columnNo]);
                                                    else if (copyType == 1)
                                                        newRow.newName = rowSeperatedStrings[columnNo];
                                                    break;
                                                case 8: newRow.angle = GetDoubleFromString(rowSeperatedStrings[columnNo]);
                                                    break;
                                                case 9: newRow.slope = GetDoubleFromString(rowSeperatedStrings[columnNo]);
                                                    break;
                                                case 10: newRow.moveType = rowSeperatedStrings[columnNo];
                                                    break;
                                                case 11: newRow.newName = rowSeperatedStrings[columnNo];
                                                    break;
                                                case 12: newRow.newName = rowSeperatedStrings[columnNo];  //10 and 25 are neighbours
                                                    break;
                                                //case 13: newRow.ccpName = rowSeperatedStrings[columnNo];
                                                //    break;
                                                //case 14: newRow.ccpStandard = rowSeperatedStrings[columnNo];
                                                //    break;
                                                //default:
                                                //    if (columnNo + copyOffset >= Const.FIRST_PARAMETER_COLUMN_TEXT //where to start
                                                //        && columnNo + copyOffset < Const.FIRST_PARAMETER_COLUMN_TEXT + noOfCCPParams) //no of parameters
                                                //    {
                                                //        newRow.ccpParameters.Add(rowSeperatedStrings[columnNo]);
                                                //    }
                                                //    break;
                                            }
                                        }

                                        //listOfClasses.Add(num1);
                                    }
                                    catch (Exception e)
                                    {
                                        MessageBox.Show("Wrong input format. File: " + path);
                                        wrongFile = true;
                                        break;
                                    }
                                }
                            }

                       
                        if (wrongFile)
                            break;

                        if (rowNo >= firstRow && newRow != null) rowList.Add(newRow);
                        rowNo++;
                        if (rowNo > lastRow)
                            break;
                        rowString = SR.ReadLine();
                    }
                }
                SR.Close();
            }
            catch (Exception e)
            {
                MessageBox.Show(" File:" + path + " could not be read.");
            }

            return rowList;
        }
    }

    public class CCPParamterType
    {
        public string name;
        public int type;

        public CCPParamterType()
        {
            type = Const.CCP_TYPE_STRING;
            name = "";
        }
    }

    public class ExcelRow
    {
        public Tekla.Structures.Geometry3d.Point newPoint;
        public double phi;
        public double angle;
        public double slope;
        public string moveType;
        public string newName;
        public string ccpName;
        public string ccpStandard;
        public ArrayList ccpParameters;

        public ExcelRow()
        {
            newPoint = new Tekla.Structures.Geometry3d.Point();
            phi = 0;
            angle = 0;
            slope = 0;
            moveType = "";
            newName = "";
            ccpName = "";
            ccpStandard = "";
            ccpParameters = new ArrayList();
        }

        //public ExcelRow(Tekla.Structures.Geometry3d.Point newPoint, double phi, double angle, double slope, string moveType, string newName)
        //{
        //    this.newPoint = newPoint;
        //    this.phi = phi;
        //    this.angle = angle;
        //    this.slope = slope;
        //    this.moveType = moveType;
        //    this.newName = newName;
        //    this.ccpName = ccpName;
        //    this.ccpStandard = ccpStandard;
        //}    
    }



    /// <summary>
    /// The script portion of the macro
    /// This is what will be called first by Tekla Structures when run as a macro
    /// </summary>
    public class Script
    {    

        public static void Run(Tekla.Technology.Akit.IScript akit_in)
        {
            System.Runtime.Remoting.Lifetime.ClientSponsor sponsor = null;
            try
            {
                sponsor = new System.Runtime.Remoting.Lifetime.ClientSponsor();
                sponsor.Register((System.MarshalByRefObject)akit_in);
                Application.Run(new MoveObjectsForm(akit_in));
            }
            catch (Exception ex)
            {
                System.Windows.Forms.MessageBox.Show(ex.Message + "\n" + ex.StackTrace);
            }
            finally
            {
                if (sponsor != null)
                {
                    sponsor.Close();
                }
            }
        }
    }
}


namespace TeklaControls
{
    /// Version 2.0
    /// <summary>
    /// A generic save and load control which mimics the functionality of the standard Tekla Structures save and load control.
    /// Note that it is necessary to call the method InitializeFileList() after the parent dialog or component has been created.
    /// </summary>
    /// <remarks>For optimum performance, place this control in the top of a dilaog setting its docking type to Top.
    /// </remarks>
    public class TeklaSaveLoadControl : System.Windows.Forms.UserControl
    {
        #region Constructors
        /// <summary>
        /// Initiates the control with the specified file extension.
        /// </summary>
        /// <param name="FileExtension">The file extension the control will load parameters from and save to</param>
        /// <param name="Language">The language to use in the user interface of the control</param>
        public TeklaSaveLoadControl(string fileExtension, string language)
        {
            // This call is required by the Windows.Forms Form Designer.
            InitializeComponent();
            SetLanguage(language);
            this.FileExtension = fileExtension;
            InitializeAttributeFileDirectories();
        }

        /// <summary>
        /// Initializes the list of serach directories to the standard Tekla search directories (model, XS_PROJECT, XS_FIRM, system)
        /// </summary>
        private void InitializeAttributeFileDirectories()
        {
            try
            {
                m_AttributeFileDirectories = EnvironmentFiles.GetStandardPropertyFileDirectories();
            }
            catch (System.Exception e)
            {
                MessageBox.Show("Exception:\n" + e.Message + "\n" + e.StackTrace);
            }
        }

        /// <summary>
        /// Sets the language for the SaveLoad control button labels
        /// </summary>
        /// <param name="lang"></param>
        private void SetLanguage(string lang)
        {
            switch (lang)
            {
                //case ("JAPANESE"):
                //    this.buttonLoad.Text = "読込み(&L)";
                //    this.buttonSave.Text = "上書保存(&S)";
                //    this.buttonSaveAs.Text = "名前付けて保存";
                //    break;
                //case ("GERMAN"):
                //    this.buttonLoad.Text = "&Laden";
                //    this.buttonSave.Text = "&Sichern";
                //    this.buttonSaveAs.Text = "Sichern als";
                //    break;
                //case ("FRENCH"):
                //    this.buttonLoad.Text = "&Charger";
                //    this.buttonSave.Text = "&Enregistrer";
                //    this.buttonSaveAs.Text = "Enregistrer sous";
                //    break;
                //case ("ENGLISH"):
                default:
                    //this.buttonLoad.Text = "&Load";
                    //this.buttonSave.Text = "&Save";
                    //this.buttonSaveAs.Text = "Save as";
                    break;
            }
        }
        #endregion

        #region Private Properties
        private string m_FileExtension = "myExtension";
        private List<string> m_AttributeFileDirectories;
        private string m_PathToHelpFile = null;
        #endregion

        #region Public Properties

        /// <summary>
        /// Gets or sets the file extension for attribute files loaded and saved by this control.
        /// By default the file extension is "myExtension"
        /// </summary>
        /// <value>the file extension</value>
        /// <remarks>Note that any "." characters will be removed from the beginning and end of the file extension</remarks>
        public string FileExtension
        {
            get
            {
                return m_FileExtension;
            }
            set
            {
                m_FileExtension = value.Trim('.');
            }
        }

        /// <summary>
        /// Gets or sets the text in the SaveAs text box
        /// </summary>
        public string SaveAsText
        {
            get
            {
                return this.textBoxSaveAs.Text;
            }
            set
            {
                if (value != null)
                {
                    this.textBoxSaveAs.Text = value;
                }
                else
                {
                    this.textBoxSaveAs.Text = "";
                }
            }
        }

        /// <summary>
        /// Gets the currently selected file name in the Save/Load combo box. 
        /// </summary>
        public string SaveLoadText
        {
            get
            {
                return this.comboBoxFileList.Text;
            }
        }

        /// <summary>
        /// Gets or sets the path to the help file.
        /// </summary>
        public string PathToHelpFile
        {
            get
            {
                return m_PathToHelpFile;
            }
            set
            {
                m_PathToHelpFile = value;
            }
        }
        #endregion

        #region Public Methods
        /// <summary>
        /// Updates (populates) the file list and if a "standard" file exists, loads it.
        /// </summary>
        public void InitializeFileList()
        {
            try
            {
                // Initialize local variables for save and load as necessary
                this.comboBoxFileList_update();
                if (this.comboBoxFileList.Items.Contains("standard"))
                {
                    this.comboBoxFileList.Text = "standard";
                    buttonLoad_Click(null, null);
                }
                this.Focus();
            }
            catch (System.Exception e)
            {
                MessageBox.Show("Exception:\n" + e.Message + "\n" + e.StackTrace);
            }
        }

        #endregion

        #region Public Events
        /// <summary>
        /// This event is triggered just before attributes are loaded into the dialog
        /// </summary>
        public event EventHandler AttributesLoading;

        /// <summary>
        /// This event is triggered just after attributes have been loaded into the dialog
        /// </summary>
        public event EventHandler AttributesLoaded;

        /// <summary>
        /// This event is triggered just before attributes are saved to a file
        /// </summary>
        public event EventHandler AttributesSaving;

        /// <summary>
        /// This event is triggered just after attributes are saved to a file
        /// </summary>
        public event EventHandler AttributesSaved;

        #endregion

        #region Save, Load, and SaveAs functions

        /// <summary>
        /// Updates or re-populates the file list
        /// </summary>
        private void comboBoxFileList_update()
        {
            try
            {
                List<string> fileList = EnvironmentFiles.GetMultiDirectoryFileList(m_AttributeFileDirectories, m_FileExtension);
                this.comboBoxFileList.Items.Clear();
                foreach (string nextFile in fileList)
                {
                    this.comboBoxFileList.Items.Add(nextFile);
                }
                this.comboBoxFileList.Sorted = true;
                this.comboBoxFileList.Update();
            }
            catch (System.Exception e)
            {
                MessageBox.Show("Exception:\n" + e.Message + "\n" + e.StackTrace);
            }
        }

        /// <summary>
        /// Saves the dialog properties to the currently selected file name and calls any AttributesSaved events for additional save related routines
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonSave_Click(object sender, System.EventArgs e)
        {
            SaveAttributeFile(this.comboBoxFileList.Text);
            if (AttributesSaving != null)
            {
                try
                {
                    AttributesSaving(null, null);
                }
                catch { }
            }
        }

        /// <summary>
        /// Loads the dialog properties from the currently selected file name and calls any AttributesLoading and AttributesLoaded events for additional load related routines
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonLoad_Click(object sender, System.EventArgs e)
        {
            try
            {
                if (AttributesLoading != null)
                {
                    AttributesLoading(null, null);
                }
                FileInfo fi = EnvironmentFiles.GetAttributeFile(m_AttributeFileDirectories, this.comboBoxFileList.Text + "." + m_FileExtension);
                if (fi == null)
                {
                    MessageBox.Show("The file [" + this.comboBoxFileList.Text + "." + m_FileExtension + "] could not be found.");
                }
                else
                {
                    // Should add a routine to clear all controls
                    ClearFields(this.Parent);
                    using (StreamReader sr = new StreamReader(fi.FullName))
                    {
                        string line = sr.ReadLine();
                        while (line != null)
                        {
                            if (line.IndexOf(" ") > 0)
                            {
                                string control = line.Substring(0, line.IndexOf(" "));
                                string setting = line.Substring(line.IndexOf(" ")).Trim();
                                SetFormAttribute(this.Parent, control, setting);
                            }
                            line = sr.ReadLine();
                        }
                    }
                }
                if (AttributesLoaded != null)
                {
                    AttributesLoaded(null, null);
                }
            }
            catch (Exception ex)
            {
                System.Windows.Forms.MessageBox.Show(ex.Message + "\n" + ex.StackTrace);
            }
        }

        /// <summary>
        /// Saves the dialog properties to the save as file name and calls any AttributesSaved events for additional save related routines
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonSaveAs_Click(object sender, System.EventArgs e)
        {
            if (AttributesSaving != null)
            {
                try
                {
                    AttributesSaving(null, null);
                }
                catch { }
            }
            if (SaveAttributeFile(this.textBoxSaveAs.Text))
            {
                comboBoxFileList_update();
                this.comboBoxFileList.Text = this.textBoxSaveAs.Text;
                if (AttributesSaved != null)
                {
                    try
                    {
                        AttributesSaved(null, null);
                    }
                    catch { }
                }
            }
        }

        private void buttonHelp_Click(object sender, EventArgs e)
        {
            if (!string.IsNullOrEmpty(PathToHelpFile))
            {
                Help.ShowHelp(this, PathToHelpFile, Const.MACRO_HELP_LINK);
            }
        }

        private bool SaveAttributeFile(string fileName)
        {
            if (fileName == null || fileName == "")
                return false;

            try
            {
                using (StreamWriter sw = new StreamWriter(m_AttributeFileDirectories[0] + fileName + "." + m_FileExtension))
                {
                    foreach (Control ct in this.Parent.Controls)
                    {
                        WriteControlToFile(ct, sw);
                    }
                }
            }
            catch (Exception e)
            {
                MessageBox.Show("Couldn't save file.\n" + e.Message);
                return false;
            }
            return true;
        }

        private void WriteControlToFile(Control ct, StreamWriter sw)
        {
            try
            {
                // Skip the SaveAs and Load controls
                if (ct.Equals(this.comboBoxFileList) ||
                    ct.Equals(this.textBoxSaveAs))
                {
                    return;
                }
                else if (ct.HasChildren)
                {
                    foreach (Control subControl in ct.Controls)
                    {
                        WriteControlToFile(subControl, sw);
                    }
                }
                else
                {
                    if (ct is System.Windows.Forms.TextBox)
                    {
                        System.Windows.Forms.TextBox ctOut = (System.Windows.Forms.TextBox)ct;
                        sw.WriteLine(ctOut.Name + " " + ctOut.Text);
                    }
                    else if (ct is System.Windows.Forms.ComboBox)
                    {
                        System.Windows.Forms.ComboBox ctOut = (System.Windows.Forms.ComboBox)ct;
                        sw.WriteLine(ctOut.Name + " " + ctOut.Text);
                    }
                    else if (ct is System.Windows.Forms.RadioButton)
                    {
                        System.Windows.Forms.RadioButton ctOut = (System.Windows.Forms.RadioButton)ct;
                        sw.WriteLine(ctOut.Name + " " + ctOut.Checked.ToString());
                    }
                    else if (ct is System.Windows.Forms.CheckBox)
                    {
                        System.Windows.Forms.CheckBox ctOut = (System.Windows.Forms.CheckBox)ct;
                        sw.WriteLine(ctOut.Name + " " + ctOut.CheckState.ToString());
                    }
                    else if (ct is System.Windows.Forms.CheckedListBox)
                    {
                        System.Windows.Forms.CheckedListBox ctOut = (System.Windows.Forms.CheckedListBox)ct;
                        foreach (int i in ctOut.CheckedIndices)
                        {
                            sw.WriteLine(ctOut.Name + " " + ctOut.Items[i].ToString());
                        }
                    }
                }
            }
            catch (Exception e)
            {
                System.Windows.Forms.MessageBox.Show(e.Message + "\n" + e.StackTrace);
            }
        }

        private void ClearFields(Control ct)
        {
            try
            {
                // Skip the SaveAs and Load controls
                if (ct.Equals(this.comboBoxFileList) ||
                    ct.Equals(this.textBoxSaveAs))
                {
                    return;
                }
                else if (ct.HasChildren)
                {
                    foreach (Control subControl in ct.Controls)
                    {
                        ClearFields(subControl);
                    }
                }
                else
                {
                    switch (ct.GetType().Name)
                    {
                        case ("TextBox"):
                            {
                                System.Windows.Forms.TextBox ctSet = (System.Windows.Forms.TextBox)ct;
                                ctSet.Text = "";
                                break;
                            }
                        case ("ComboBox"):
                            {
                                System.Windows.Forms.ComboBox ctSet = (System.Windows.Forms.ComboBox)ct;
                                ctSet.Text = "";
                                break;
                            }
                        case ("RadioButton"):
                            {
                                System.Windows.Forms.RadioButton ctSet = (System.Windows.Forms.RadioButton)ct;
                                ctSet.Checked = false;
                                break;
                            }
                        case ("CheckBox"):
                            {
                                System.Windows.Forms.CheckBox ctSet = (System.Windows.Forms.CheckBox)ct;
                                ctSet.CheckState = CheckState.Unchecked;
                                break;
                            }
                        case ("CheckedListBox"):
                            {
                                System.Windows.Forms.CheckedListBox ctSet = (System.Windows.Forms.CheckedListBox)ct;
                                for (int i = ctSet.Items.Count - 1; i >= 0; i--)
                                {
                                    ctSet.SetItemCheckState(i, CheckState.Unchecked);
                                }
                                break;
                            }
                    }
                }
            }
            catch (Exception e)
            {
                System.Windows.Forms.MessageBox.Show(e.Message + "\n" + e.StackTrace);
            }
        }

        private void SetFormAttribute(Control ct, string control, string setting)
        {
            try
            {
                if (ct.HasChildren)
                {
                    foreach (Control subCt in ct.Controls)
                    {
                        SetFormAttribute(subCt, control, setting);
                    }
                }
                else
                {
                    if (ct.Name == control)
                    {
                        switch (ct.GetType().Name)
                        {
                            case ("TextBox"):
                                {
                                    System.Windows.Forms.TextBox ctSet = (System.Windows.Forms.TextBox)ct;
                                    ctSet.Text = setting;
                                    break;
                                }
                            case ("ComboBox"):
                                {
                                    System.Windows.Forms.ComboBox ctSet = (System.Windows.Forms.ComboBox)ct;
                                    ctSet.Text = setting;
                                    break;
                                }
                            case ("RadioButton"):
                                {
                                    System.Windows.Forms.RadioButton ctSet = (System.Windows.Forms.RadioButton)ct;
                                    ctSet.Checked = bool.Parse(setting);
                                    break;
                                }
                            case ("CheckBox"):
                                {
                                    System.Windows.Forms.CheckBox ctSet = (System.Windows.Forms.CheckBox)ct;
                                    ctSet.CheckState = parseCheckState(setting);
                                    break;
                                }
                            case ("CheckedListBox"):
                                {
                                    System.Windows.Forms.CheckedListBox ctSet = (System.Windows.Forms.CheckedListBox)ct;
                                    for (int i = ctSet.Items.Count - 1; i >= 0; i--)
                                    {
                                        if (ctSet.Items[i].ToString().Equals(setting))
                                        {
                                            ctSet.SetItemCheckState(i, CheckState.Checked);
                                        }
                                    }
                                    break;
                                }
                        }
                    }
                }
            }
            catch (Exception e)
            {
                System.Windows.Forms.MessageBox.Show(e.Message + "\n" + e.StackTrace);
            }
        }

        private CheckState parseCheckState(string state)
        {
            switch (state)
            {
                case "Unchecked":
                    return CheckState.Unchecked;
                case "Checked":
                    return CheckState.Checked;
                default:
                    return CheckState.Indeterminate;
            }
        }
        #endregion

        #region Designer Code
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.IContainer components = null;

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            base.Dispose(disposing);
        }
        #region Component Designer generated code

        /// <summary> 
        /// Required method for Designer support - do not modify 
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(TeklaSaveLoadControl));
            this.groupBoxSaveLoad = new System.Windows.Forms.GroupBox();
            this.tableLayoutPanel1 = new System.Windows.Forms.TableLayoutPanel();
            this.textBoxSaveAs = new System.Windows.Forms.TextBox();
            this.buttonSaveAs = new System.Windows.Forms.Button();
            this.comboBoxFileList = new System.Windows.Forms.ComboBox();
            this.buttonLoad = new System.Windows.Forms.Button();
            this.buttonSave = new System.Windows.Forms.Button();
            this.buttonHelp = new System.Windows.Forms.Button();
            this.groupBoxSaveLoad.SuspendLayout();
            this.tableLayoutPanel1.SuspendLayout();
            this.SuspendLayout();
            // 
            // groupBoxSaveLoad
            // 
            this.groupBoxSaveLoad.Controls.Add(this.tableLayoutPanel1);
            this.groupBoxSaveLoad.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.groupBoxSaveLoad.Name = "groupBoxSaveLoad";
            this.groupBoxSaveLoad.TabStop = false;
            // 
            // tableLayoutPanel1
            //
            this.tableLayoutPanel1.Controls.Add(this.buttonHelp, 5, 0);
            this.tableLayoutPanel1.Controls.Add(this.textBoxSaveAs, 4, 0);
            this.tableLayoutPanel1.Controls.Add(this.buttonSaveAs, 3, 0);
            this.tableLayoutPanel1.Controls.Add(this.comboBoxFileList, 2, 0);
            this.tableLayoutPanel1.Controls.Add(this.buttonLoad, 1, 0);
            this.tableLayoutPanel1.Controls.Add(this.buttonSave, 0, 0);
            this.tableLayoutPanel1.Name = "tableLayoutPanel1";
            // 
            // textBoxSaveAs
            // 
            this.textBoxSaveAs.Name = "textBoxSaveAs";
            this.textBoxSaveAs.Anchor = AnchorStyles.Top | AnchorStyles.Right | AnchorStyles.Left;
            this.textBoxSaveAs.Location = new System.Drawing.Point(363, 3);
            this.textBoxSaveAs.Size = new System.Drawing.Size(150, 20);
            this.textBoxSaveAs.TabIndex = 5;
            this.textBoxSaveAs.Parent = this.tableLayoutPanel1;
            // 
            // buttonSaveAs
            // 
            this.buttonSaveAs.Name = "buttonSaveAs";
            this.buttonSaveAs.Click += new System.EventHandler(this.buttonSaveAs_Click);
            this.buttonSaveAs.AutoSize = true;
            this.buttonSaveAs.AutoSizeMode = AutoSizeMode.GrowAndShrink;
            this.buttonSaveAs.Location = new System.Drawing.Point(301, 3);
            this.buttonSaveAs.Size = new System.Drawing.Size(56, 22);
            this.buttonSaveAs.TabIndex = 4;
            this.buttonSaveAs.Text = "Save &as";
            this.buttonSaveAs.Parent = this.tableLayoutPanel1;
            // 
            // comboBoxFileList
            // 
            this.comboBoxFileList.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxFileList.Name = "comboBoxFileList";
            this.comboBoxFileList.Anchor = AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Right;
            this.comboBoxFileList.Location = new System.Drawing.Point(95, 3);
            this.comboBoxFileList.Size = new System.Drawing.Size(150, 20);
            this.comboBoxFileList.TabIndex = 3;
            this.comboBoxFileList.Name = "comboBoxFileList";
            this.comboBoxFileList.Parent = this.tableLayoutPanel1;
            // 
            // buttonLoad
            // 
            this.buttonLoad.Name = "buttonLoad";
            this.buttonLoad.Click += new System.EventHandler(this.buttonLoad_Click);
            this.buttonLoad.AutoSize = true;
            this.buttonLoad.AutoSizeMode = AutoSizeMode.GrowAndShrink;
            this.buttonLoad.Location = new System.Drawing.Point(49, 3);
            this.buttonLoad.Size = new System.Drawing.Size(40, 22);
            this.buttonLoad.TabIndex = 2;
            this.buttonLoad.Text = "&Load";
            this.buttonLoad.Parent = this.tableLayoutPanel1;
            // 
            // buttonSave
            // 
            this.buttonSave.Name = "buttonSave";
            this.buttonSave.Click += new System.EventHandler(this.buttonSave_Click);
            this.buttonSave.AutoSize = true;
            this.buttonSave.AutoSizeMode = AutoSizeMode.GrowAndShrink;
            this.buttonSave.Location = new System.Drawing.Point(3, 3);
            this.buttonSave.Size = new System.Drawing.Size(40, 22);
            this.buttonSave.TabIndex = 1;
            this.buttonSave.Text = "&Save";
            this.buttonSave.Parent = this.tableLayoutPanel1;
            // 
            // buttonHelp
            //
            this.buttonHelp.Name = "buttonHelp";
            this.buttonHelp.Click += new System.EventHandler(this.buttonHelp_Click);
            this.buttonHelp.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.buttonHelp.AutoSize = true;
            this.buttonHelp.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
            this.buttonHelp.Location = new System.Drawing.Point(786, 692);
            this.buttonHelp.Size = new System.Drawing.Size(48, 23);
            this.buttonHelp.TabIndex = 7;
            this.buttonHelp.Text = "&Help";
            this.buttonHelp.Parent = this.tableLayoutPanel1;
            // 
            // TeklaSaveLoadControl
            // 
            this.Controls.Add(this.groupBoxSaveLoad);
            this.MinimumSize = new System.Drawing.Size(474, 48);
            this.Name = "TeklaSaveLoadControl";
            // 
            // tableLayoutPanel1
            // 
            this.tableLayoutPanel1.Dock = DockStyle.Fill;
            this.tableLayoutPanel1.Location = new System.Drawing.Point(3, 12);
            this.tableLayoutPanel1.Margin = new Padding(3, 0, 3, 3);
            this.tableLayoutPanel1.Size = new System.Drawing.Size(462, 30);
            this.tableLayoutPanel1.TabIndex = 0;
            this.tableLayoutPanel1.Name = "tableLayoutPanel1";
            this.tableLayoutPanel1.Parent = this.groupBoxSaveLoad;
            // 
            // groupBoxSaveLoad
            // 
            this.groupBoxSaveLoad.Dock = DockStyle.Fill;
            this.groupBoxSaveLoad.Location = new System.Drawing.Point(3, 0);
            this.groupBoxSaveLoad.Padding = new Padding(3, 0, 3, 3);
            this.groupBoxSaveLoad.Size = new System.Drawing.Size(468, 45);
            this.groupBoxSaveLoad.TabIndex = 0;
            this.groupBoxSaveLoad.Name = "groupBoxSaveLoad";
            this.groupBoxSaveLoad.Parent = this;
            this.Padding = new Padding(3, 0, 3, 3);
            this.Size = new System.Drawing.Size(474, 48);

            this.groupBoxSaveLoad.ResumeLayout(false);
            this.tableLayoutPanel1.ResumeLayout(false);
            this.tableLayoutPanel1.PerformLayout();
            this.ResumeLayout(false);
        }

        #endregion

        private System.Windows.Forms.GroupBox groupBoxSaveLoad;
        internal System.Windows.Forms.ComboBox comboBoxFileList;
        internal System.Windows.Forms.TextBox textBoxSaveAs;
        internal System.Windows.Forms.Button buttonSaveAs;
        internal System.Windows.Forms.Button buttonLoad;
        internal System.Windows.Forms.Button buttonSave;
        internal System.Windows.Forms.Button buttonHelp;
        private System.Windows.Forms.TableLayoutPanel tableLayoutPanel1;

        #endregion
    }

    public class Language
    {
        public static string GetTeklaStructuresLanguage()
        {
            // Check if we can identify the language that Tekla Structures was started in
            string language = EnvironmentVariables.GetEnvironmentVariable("XS_LANGUAGE");
            if (language == null || language == "")
            {
                language = "XXX";
            }
            return language;
        }
    }

    /// <summary>
    /// A set of tools for parsing text to "Tekla" values
    /// </summary>
    public class Parsers
    {
        /// <summary>
        /// Stores the Tekla numberFormatinfo
        /// </summary>
        private static NumberFormatInfo m_TeklaNumberFormat;
        private const string DecimalSeparator = ".";
        private const string GroupSeparator = ",";

        /// <summary>
        /// Initializes the class so we have the "Tekla" numberFormatInfo available
        /// </summary>
        static Parsers()
        {
            m_TeklaNumberFormat = new NumberFormatInfo();
            m_TeklaNumberFormat.NumberDecimalSeparator = DecimalSeparator;
            m_TeklaNumberFormat.NumberGroupSeparator = GroupSeparator;
            m_TeklaNumberFormat.NumberDecimalSeparator = DecimalSeparator;
            m_TeklaNumberFormat.NumberGroupSeparator = GroupSeparator;
            m_TeklaNumberFormat.CurrencyDecimalSeparator = DecimalSeparator;
            m_TeklaNumberFormat.CurrencyGroupSeparator = GroupSeparator;
            m_TeklaNumberFormat.PercentDecimalSeparator = DecimalSeparator;
            m_TeklaNumberFormat.PercentGroupSeparator = GroupSeparator;
        }

        public static List<double> DistanceListToList(string text)
        {
            string[] chunks = text.Trim().Split(new char[] { ' ' }, StringSplitOptions.RemoveEmptyEntries);
            List<double> distList = new List<double>();
            for (int i = 0; i < chunks.GetLength(0); i++)
            {
                if (chunks[i].IndexOf("*") > -1)
                {
                    int multiplier = ParseInt(chunks[i].Split(new char[] { '*' })[0], 1);
                    double distance = ParseDouble(chunks[i].Split(new char[] { '*' })[1]);
                    for (int j = 0; j < multiplier; j++)
                    {
                        distList.Add(distance);
                    }
                }
                else
                {
                    double val = ParseDouble(chunks[i], double.MinValue);
                    if (val != double.MinValue)
                        distList.Add(val);
                }
            }
            return distList;
        }

        public static double[] DistanceListToArray(string text)
        {
            return DistanceListToList(text).ToArray();
        }

        public static double ParseDouble(string text)
        {
            return ParseDouble(text, 0);
        }

        public static double ParseDouble(string text, double def)
        {
            try
            {
                return double.Parse(text, m_TeklaNumberFormat);
            }
            catch
            {
                return def;
            }
        }

        public static int ParseInt(string text)
        {
            return ParseInt(text, 0);
        }

        public static int ParseInt(string text, int def)
        {
            try
            {
                return int.Parse(text, m_TeklaNumberFormat);
            }
            catch
            {
                return def;
            }
        }
    }

    public class EnvironmentFiles
    {
        private static List<string> m_PropertyFileDirectories = GetStandardPropertyFileDirectories();
        public static List<string> PropertyFileDirectories
        {
            get
            {
                return m_PropertyFileDirectories;
            }
            set
            {
                m_PropertyFileDirectories = value;
            }
        }

        public static List<string> GetStandardPropertyFileDirectories()
        {
            List<string> fileDirectories = new List<string>();
            try
            {
                // First attempt to add the model/attributes/ directory
                Tekla.Structures.Model.Model model;
                if (ModelAccess.ConnectToModel(out model))
                {
                    string modelPath = model.GetInfo().ModelPath;
                    // Check first for an "./attributes/" directory. If one is not found use the local directory.
                    if (IsValidDirectory(modelPath + @"/attributes/"))
                    {
                        fileDirectories.Add(modelPath + @"/attributes/");
                    }
                    else if (IsValidDirectory(modelPath + @"/"))
                    {
                        fileDirectories.Add(modelPath + @"/");
                    }
                }
                if (fileDirectories.Count == 0 && IsValidDirectory(@"./"))
                {
                    fileDirectories.Add(@"./");
                }

                // Now add any Tekla Structures standard environment directories
                AddPaths(fileDirectories, "XS_PROJECT");
                AddPaths(fileDirectories, "XS_FIRM");
                AddPaths(fileDirectories, "XS_SYSTEM");
            }
            catch (System.Exception e)
            {
                Console.WriteLine("Exception:\n{0}\n{1}", e.Message, e.StackTrace);
            }
            return fileDirectories;
        }

        private static void AddPaths(List<string> fileDirectories, string environmentVariableName)
        {
            char[] semiColon = new char[] { ';' };
            string[] xs_Project = EnvironmentVariables.GetEnvironmentVariable(environmentVariableName).Split(semiColon);
            foreach (string path in xs_Project)
            {
                string cleanPath = path.Replace(@"\\\\", @"\\");
                if (IsValidDirectory(cleanPath))
                    fileDirectories.Add(cleanPath);
            }
        }

        public static bool IsValidDirectory(string directory)
        {
            if (directory == null || directory == "")
                return false;
            return Directory.Exists(directory);
        }

        public static List<string> GetMultiDirectoryFileList(string fileExtension)
        {
            return GetMultiDirectoryFileList(PropertyFileDirectories, fileExtension);
        }

        /// <summary>
        /// Gets a list of files with the given extension from the list of directories.
        /// </summary>
        /// <param name="searchDirectories"></param>
        /// <param name="fileExtension"></param>
        /// <returns>A list of found files names without the file extension</returns>
        public static List<string> GetMultiDirectoryFileList(List<string> searchDirectories, string fileExtension)
        {
            List<string> fileList = new List<string>();
            fileExtension = "." + fileExtension;
            foreach (string nextDirectory in searchDirectories)
            {
                try
                {
                    if (Directory.Exists(nextDirectory))
                    {
                        DirectoryInfo di = new DirectoryInfo(nextDirectory);
                        FileInfo[] fi = di.GetFiles("*" + fileExtension);
                        foreach (FileInfo nextFile in fi)
                        {
                            if (nextFile != null && nextFile.Exists && nextFile.Extension == fileExtension)
                            {
                                string fileName = nextFile.Name.Substring(0, nextFile.Name.Length - fileExtension.Length);
                                if (!fileList.Contains(fileName))
                                {
                                    fileList.Add(fileName);
                                }
                            }
                        }
                    }
                }
                catch (Exception e)
                {
                    System.Windows.Forms.MessageBox.Show(e.Message + "\n" + e.StackTrace);
                }
            }
            fileList.Sort(Sorting.TeklaSort.CompareLikeTekla);
            return fileList;
        }

        /// <summary>
        /// Gets FileInfo representing the first match in the standard property file directories.
        /// </summary>
        /// <param name="fileName">the name of the file including file extension</param>
        /// <returns>a FileInfo for the first match in the directory list, null if no match was found.</returns>
        public static FileInfo GetAttributeFile(string fileName)
        {
            return GetAttributeFile(PropertyFileDirectories, fileName);
        }

        /// <summary>
        /// Gets FileInfo representing the first match in the search directories.
        /// </summary>
        /// <param name="searchDirectories">the list of directories to search for the file</param>
        /// <param name="fileName">the name of the file including file extension</param>
        /// <returns>a FileInfo for the first match in the directory list, null if no match was found.</returns>
        public static FileInfo GetAttributeFile(List<string> searchDirectories, string fileName)
        {
            try
            {
                foreach (string di in searchDirectories)
                {
                    if (File.Exists(di + fileName))
                    {
                        return new FileInfo(di + fileName);
                    }
                }
            }
            catch (System.Exception e)
            {
                Console.WriteLine("Exception:\n{0}\n{1}", e.Message, e.StackTrace);
            }
            return null;
        }

    }

    /// <summary>
    /// A class of helper methods for connecting to and accessing the model and objects in the model.
    /// Attempts to provide efficient but robust methods for connecting to and verifying connection to the model.
    /// Also provides efficient methods for enumeration and generation of lists strongly typed to specific ModelObject types.
    /// </summary>
    public class ModelAccess
    {
        private static Tekla.Structures.Model.Model m_ModelConnection = null;

        /// <summary>
        /// Checks if a model connection is established, and attempts to create one if needed.
        /// </summary>
        /// <returns>true if successfully connected to the  model, false otherwise</returns>
        private static bool ConnectedToModel
        {
            get
            {
                bool connection = false;
                ConnectToModel(out connection);
                return connection;
            }
        }

        /// <summary>
        /// Gets a Model connnection
        /// </summary>
        /// <returns>The Model or null if unable to connect</returns>
        public static Tekla.Structures.Model.Model ConnectToModel()
        {
            bool connection = false;
            return ConnectToModel(out connection);
        }

        /// <summary>
        /// Gets a model connection
        /// </summary>
        /// <param name="model">the Model connection</param>
        /// <returns>true on success, false otherwise</returns>
        public static bool ConnectToModel(out Tekla.Structures.Model.Model model)
        {
            bool connection = false;
            ConnectToModel(out connection);
            model = m_ModelConnection;
            return connection;
        }

        /// <summary>
        /// Gets a Model connection
        /// </summary>
        /// <param name="ConnectedToModel">set to true if a model connection was made, false otherwise.</param>
        /// <returns>The Model or null if unable to connect</returns>
        public static Tekla.Structures.Model.Model ConnectToModel(out bool ConnectedToModel)
        {
            ConnectedToModel = false;
            if (m_ModelConnection == null)
            {
                try
                {
                    m_ModelConnection = new Tekla.Structures.Model.Model();
                }
                catch
                {
                    ConnectedToModel = false;
                }
            }
            if (m_ModelConnection.GetConnectionStatus())
            {
                if (m_ModelConnection.GetInfo().ModelName == "")
                {
                    ConnectedToModel = false;
                }
                else
                {
                    ConnectedToModel = true;
                }
            }
            return m_ModelConnection;
        }
    }

    class Sorting
    {
        /// <summary>
        /// An IComparer interface to sort lists in the same way that Tekla attribute and report lists are sorted.
        /// </summary>
        /// <remarks>Tekla Structures sorting places lowercase letters before uppercase letters.
        /// In all other cases, the local cultural info is used for sorting.
        /// Note that using this comparer will tread upper and lowercase letters as different.</remarks>
        public class TeklaSort : IComparable<string>, IComparer
        {
            public static int CompareLikeTekla(string x, string y)
            {
                char[] s1 = x.ToCharArray();
                char[] s2 = y.ToCharArray();
                int max = ((s1.Length < s2.Length) ? s1.Length : s2.Length);
                for (int i = 0; i < max; i++)
                {
                    if (s1[i] != s2[i])
                    {
                        if ((char.IsUpper(s1[i]) && char.IsLower(s2[i])))
                        {
                            return -1;
                        }
                        else if ((char.IsUpper(s2[i]) && char.IsLower(s1[i])))
                        {
                            return 1;
                        }
                        else
                        {
                            return (new Comparer(System.Threading.Thread.CurrentThread.CurrentCulture).Compare(x, y));
                        }
                    }
                }
                return (new Comparer(System.Threading.Thread.CurrentThread.CurrentCulture).Compare(x, y));
            }

            #region IComparer Members
            public int CompareTo(string value)
            {
                return Compare(this, value);
            }

            public int Compare(object x, object y)
            {
                if ((x.GetType().Name.ToLower() == "string") && (y.GetType().Name.ToLower() == "string"))
                {
                    char[] s1 = ((string)x).ToCharArray();
                    char[] s2 = ((string)y).ToCharArray();
                    int max = ((s1.Length < s2.Length) ? s1.Length : s2.Length);
                    for (int i = 0; i < max; i++)
                    {
                        if (s1[i] != s2[i])
                        {
                            if ((char.IsUpper(s1[i]) && char.IsLower(s2[i])))
                            {
                                return -1;
                            }
                            else if ((char.IsUpper(s2[i]) && char.IsLower(s1[i])))
                            {
                                return 1;
                            }
                            else
                            {
                                break;
                            }
                        }
                    }
                }
                return ((new Comparer(System.Threading.Thread.CurrentThread.CurrentCulture).Compare(x, y)));
            }
            #endregion
        }

    }


    /// <summary>
    /// A SortedList specializing in getting active environment variables and advanced option settings.
    /// It also checks options.ini files in the active model folder as well as options_user.ini files.
    /// </summary>
    public static class EnvironmentVariables
    {
        private static SortedList<string, string> m_List = new SortedList<string, string>();

        static EnvironmentVariables()
        {
            Add("XSBIN");
            Add("USERNAME");
        }

        public static string GetEnvironmentVariable(string variableName)
        {
            if (m_List.ContainsKey(variableName))
            {
                return m_List[variableName];
            }
            else
            {
                Add(variableName);
                return Get(variableName);
            }
        }

        public static void Add(string key)
        {
            if (!m_List.ContainsKey(key))
            {
                string val = string.Empty;
                try
                {
                    bool connected = false;
                    bool added = false;
                    Tekla.Structures.Model.Model model = ModelAccess.ConnectToModel(out connected);
                    if (connected)
                    {
#if TS160 || TS161
                        added = model.GetAdvancedOption(key, ref val);
#else // TS170 || TS180
                        added = Tekla.Structures.TeklaStructuresSettings.GetAdvancedOption(key, ref val);
#endif
                    }

                    if (!connected || !added)
                    {
                        val = @System.Environment.GetEnvironmentVariable(key);

                        if (File.Exists("options.ini"))
                        {
                            StreamReader fs = File.OpenText("options.ini");
                            string line = fs.ReadLine();
                            while (line != null)
                            {
                                if (line.StartsWith(key))
                                {
                                    val = line.Substring(line.IndexOf("=") + 1);
                                    break;
                                }
                                line = fs.ReadLine();
                            }
                            fs.Close();
                        }
                        if (m_List.ContainsKey("XSBIN") && m_List.ContainsKey("USERNAME"))
                        {
                            string options_ini = m_List["XSBIN"] + "options_" + m_List["USERNAME"] + ".ini";
                            if (File.Exists(options_ini))
                            {
                                StreamReader fs = File.OpenText(options_ini);
                                string line = fs.ReadLine();
                                while (line != null)
                                {
                                    if (line.StartsWith(key))
                                    {
                                        val = line.Substring(line.IndexOf("=") + 1);
                                        break;
                                    }
                                    line = fs.ReadLine();
                                }
                                fs.Close();
                            }
                        }
                    }
                    if (val == null)
                        val = "";
                    m_List.Add(key, val);
                }
                catch (Exception e)
                {
                    System.Windows.Forms.MessageBox.Show(e.Message + "\n" + e.StackTrace);
                    m_List.Add(key, "");
                }
            }
        }

        public static string Get(string key)
        {
            if (m_List.ContainsKey(key))
            {
                return m_List[key];
            }
            return string.Empty;
        }
    }
}


/*akit.CommandStart("ail_move_translate", "", "main_frame");
akit.ValueChange("Move", "dx", (er.newPoint.X * 1000.0).ToString());
akit.ValueChange("Move", "dy", (er.newPoint.Y * 1000.0).ToString());
akit.ValueChange("Move", "dz", (er.newPoint.Z * 1000.0).ToString());
akit.PushButton("dia_move_apply", "Move");
akit.CommandEnd();*/

/*akit.CommandStart("ail_copy_translate", "", "main_frame");
akit.ValueChange("Copy", "dx", (er.newPoint.X*1000.0).ToString());
akit.ValueChange("Copy", "dy", (er.newPoint.Y*1000.0).ToString());
akit.ValueChange("Copy", "dz", (er.newPoint.Z*1000.0).ToString());
akit.PushButton("dia_copy_apply", "Copy");*/